/**********************************************************
 * ModServ2x - Modular IRC Services for advanced use.     *
 *   Based on the Undernet/Beware P10 Protocol.           *
 *   (C) 2004-2005 Christian Jurk (commx@commx.ws)        *
 *   Special thanks goes to:                              *
 *     Stephan Peijnik                                    *
 *     Linus Kimselius                                    *
 * ------------------------------------------------------ *
 * This program is released under the terms of the GNU    *
 * Public License (GPL). You'll find the License in the   *
 * docs directory shipped with this release.              *
 * ------------------------------------------------------ *
 * account.c                                              *
 * Accounting, suspends and more.                         *
 * 21/04/05 11:49 commx                                   *
 **********************************************************/

#include "include/main.h"
#include "include/account.h"
#include "include/pgsql.h"
#include "include/log.h"

#define ACR_SUPPORTADMIN 0x100
#define ACR_IRCDEV       0x200

int findaccount(char *name) {
  PGresult *res;
  strtolower(name);
  res=pg_query("SELECT * FROM users WHERE lower(account)='%s'",name);
  if (pg_num_rows(res)>0) {
    PQclear(res);
    return 1;
  } else {
    PQclear(res);
    return 0;
  }
}

void clearsuspends() {
  PGresult *res; int i=0; time_t nex; char tmpacc[40];
  res=pg_query("SELECT uid FROM accountsuspends WHERE expirets<%ld;",time(NULL));
  if (pg_num_rows(res)>0) {
    for(i=0;i<pg_num_rows(res);i++) {
      pg_query("UPDATE users SET suspended=FALSE WHERE uid=%s;",PQgetvalue(res,i,0));
    }
  }
  pg_query("DELETE FROM accountsuspends WHERE expirets<%ld",time(NULL));
  if (global_debug && i>0) flog("clearsuspends", "Cleared %d account suspensions",i);
  PQclear(res);
  /* What about expired accounts? */
  nex=time(NULL)-account_expiretime;
  res=pg_query("SELECT uid,account FROM users WHERE lastauth<%ld AND lastauth!='0';",nex);
  if (pg_num_rows(res)>0) {
    for(i=0;i<pg_num_rows(res);i++) {
      resetchar(tmpacc);
      strcp(tmpacc,PQgetvalue(res,i,1));
      strtolower(tmpacc);
      pg_query("DELETE FROM chanlevs,users WHERE lower(account)='%s';",tmpacc);
      pg_query("DELETE FROM vhosts,accountsuspends WHERE uid=%ld;",atol(PQgetvalue(res,i,0)));
    }
  }
}

int getuclev(char *acc) {
  PGresult *res,*res2; int myres;
  strtolower(acc);
  res=pg_query("SELECT ulevel FROM users WHERE lower(account)='%s';",acc);
  if (pg_num_rows(res)<1) {
    PQclear(res);
    return -1;
  }
  res2=pg_query("SELECT vtype FROM userlevels WHERE vdesc='%s'",PQgetvalue(res,0,0));
  if (pg_num_rows(res2)<1) {
    PQclear(res);
    return -1;
  }
  myres=atoi(PQgetvalue(res2,0,0));
  PQclear(res);
  PQclear(res2);
  return myres;
}

mBool is_sa(const char *acc) {
  PGresult *res;
  strtolower(acc);
  res=pg_query("SELECT ulevel FROM users WHERE lower(account)='%s';",acc);
  if (pg_num_rows(res)<1) {
    PQclear(res);
    return mFalse;
  }
  if (!strcasecmp(PQgetvalue(res,0,0),"supportadmin")) {
    return mTrue;
  } else {
    return mFalse;
  }
}
