-- modserv2x database dump
-- for postgresql databases

CREATE TABLE accountsuspends
(
  reason varchar(250) NOT NULL DEFAULT '<none>'::character varying,
  setby varchar(25) NOT NULL,
  setat varchar(10) NOT NULL,
  expirets varchar(10) NOT NULL,
  uid int8 NOT NULL
) 
WITHOUT OIDS;

CREATE TABLE avgdata
(
  firstcheck varchar(10) NOT NULL,
  checks int4 NOT NULL DEFAULT 0,
  channel varchar(200) NOT NULL,
  avg float4
) 
WITHOUT OIDS;

CREATE TABLE bans
(
  hostmask varchar(255) NOT NULL,
  expirets varchar(10) NOT NULL,
  banby varchar(25) NOT NULL,
  banat varchar(10) NOT NULL,
  breason varchar(302) NOT NULL DEFAULT 'no reason given.'::character varying,
  cid int8 NOT NULL
) 
WITHOUT OIDS;

CREATE TABLE cfdata
(
  uhash varchar(32) NOT NULL,
  score int4 NOT NULL DEFAULT 0,
  lastopped varchar(10) NOT NULL,
  chan varchar(200) NOT NULL
) 
WITHOUT OIDS;

CREATE TABLE chanlevs
(
  account varchar(20) NOT NULL,
  flags varchar(20) NOT NULL DEFAULT '+'::character varying,
  cid int8 NOT NULL
) 
WITHOUT OIDS;

CREATE TABLE channels
(
  channel varchar(202) NOT NULL,
  regtime varchar(10) NOT NULL,
  suspended bool NOT NULL DEFAULT false,
  joincount int8 NOT NULL DEFAULT 0,
  cid int8 NOT NULL DEFAULT nextval('inc_cid'::text),
  flags varchar(15) NOT NULL DEFAULT '+'::character varying,
  autolimit int4 NOT NULL DEFAULT 0
) 
WITHOUT OIDS;

CREATE TABLE glines
(
  mask varchar(200) NOT NULL,
  addedby varchar(20) NOT NULL,
  addedat varchar(10) NOT NULL,
  expirets varchar(10) NOT NULL,
  reason varchar(250) NOT NULL DEFAULT 'no reason given'::character varying
) 
WITHOUT OIDS;

CREATE TABLE greetings
(
  message varchar(300) NOT NULL,
  setby varchar(25) NOT NULL,
  setat varchar(10) NOT NULL,
  cid int8 NOT NULL
) 
WITHOUT OIDS;

CREATE TABLE memos
(
  source int8 NOT NULL,
  target int8 NOT NULL,
  message varchar(260) NOT NULL,
  sent varchar(10) NOT NULL,
  "read" bool NOT NULL DEFAULT false
) 
WITHOUT OIDS;

CREATE TABLE ochannels
(
  channel varchar(200) NOT NULL
) 
WITHOUT OIDS;

CREATE TABLE rops
(
  channel varchar(200) NOT NULL,
  nick varchar(20) NOT NULL,
  ts varchar(10) NOT NULL,
  result int2,
  opped int4 NOT NULL DEFAULT 0
) 
WITHOUT OIDS;

CREATE TABLE topics
(
  topic varchar(300) NOT NULL,
  addedby varchar(25) NOT NULL,
  addedat varchar(10) NOT NULL,
  cid int8 NOT NULL
) 
WITHOUT OIDS;

CREATE TABLE trustadmins
(
  trustgroup int4 NOT NULL DEFAULT 0,
  account varchar(20) NOT NULL,
  "level" varchar(10) NOT NULL DEFAULT 'co-admin'::character varying
) 
WITH OIDS;

CREATE TABLE trustgroups
(
  name varchar(60) NOT NULL,
  contact varchar(300) NOT NULL,
  "comment" varchar(300) NOT NULL DEFAULT '[no comment]'::character varying,
  addedby varchar(20) NOT NULL,
  addedat varchar(10) NOT NULL DEFAULT '0'::character varying,
  maxperident int4 NOT NULL DEFAULT 1,
  connections int4 NOT NULL DEFAULT 0,
  forceident bool NOT NULL DEFAULT true,
  expires varchar NOT NULL DEFAULT '0'::character varying,
  id int4 NOT NULL DEFAULT 0
) 
WITH OIDS;

CREATE TABLE trusthosts
(
  address varchar(16) NOT NULL DEFAULT '127.0.0.1'::character varying,
  maxusage int4 NOT NULL DEFAULT 0,
  lastused varchar(10) DEFAULT '0'::character varying,
  trustgroup int4 NOT NULL DEFAULT 0
) 
WITH OIDS;

CREATE TABLE userlevels
(
  vtype int4 NOT NULL DEFAULT 0,
  vdesc varchar(300) NOT NULL,
  vid int4 NOT NULL DEFAULT nextval('inc_ulv'::text)
) 
WITHOUT OIDS;

CREATE TABLE users
(
  account varchar(20) NOT NULL,
  passwd varchar(80) NOT NULL,
  email varchar(255) NOT NULL,
  lastauth varchar(10) NOT NULL DEFAULT '0'::character varying,
  created varchar(10) NOT NULL DEFAULT '0'::character varying,
  authcount int4 NOT NULL DEFAULT 0,
  authfails int4 NOT NULL DEFAULT 0,
  suspended bool NOT NULL DEFAULT false,
  ulevel varchar(80) NOT NULL DEFAULT 'user'::character varying,
  uid varchar(8) NOT NULL DEFAULT nextval('inc_uid'::text),
  activated bool NOT NULL DEFAULT false,
  actcode varchar(20) NOT NULL,
  flags varchar(20) NOT NULL DEFAULT '+'::character varying,
  lang varchar(20) DEFAULT 'english'::character varying,
  realname varchar(60) NOT NULL DEFAULT '<none>'::character varying,
  loc varchar(40) NOT NULL DEFAULT '<none>'::character varying,
  bday varchar(10) NOT NULL DEFAULT '00-00-0000'::character varying,
  lastlogin varchar(10) NOT NULL DEFAULT '0'::character varying
) 
WITHOUT OIDS;

CREATE TABLE vhosts
(
  uid int8 NOT NULL,
  vhost varchar(70) NOT NULL,
  usec int4 NOT NULL DEFAULT 0,
  vdefault bool NOT NULL DEFAULT false
) 
WITHOUT OIDS;

-- sequences

CREATE SEQUENCE inc_cid
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE SEQUENCE inc_uid
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

CREATE SEQUENCE inc_ulv
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;

-- end of database dump.
