/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : channels.h, channel database                                :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#ifndef _HAVE_CHANNELS
#define _HAVE_CHANNELS

#include <stdio.h>
#include <stdlib.h>

#define cm_o 'o'               /* channel op */
#define cm_v 'v'               /* voice */
#define cm_b 'b'               /* channel ban */
#define cm_c 'c'               /* no colours */
#define cm_C 'C'               /* no channel-wide ctcps */
#define cm_d 'd'               /* auditorium desync */
#define cm_D 'D'               /* auditorium mode */
#define cm_i 'i'               /* invite only */
#define cm_k 'k'               /* key (channel-password) */
#define cm_l 'l'               /* limit */
#define cm_m 'm'               /* moderated */
#define cm_M 'M'               /* only authed users may privmsg */
#define cm_n 'n'               /* no external messages */
#define cm_N 'N'               /* no channel notices */
#define cm_p 'p'               /* private */
#define cm_r 'r'               /* authed only */
#define cm_s 's'               /* secure */
#define cm_S 'S'               /* strip control codes */
#define cm_t 't'               /* only ops may change the topic */
#define cm_T 'T'               /* no multi-target messages (amsgs) */
#define cm_u 'u'               /* no quit/part messages */
#define cm_z 'z'               /* ssl clients only */

#define um_o                   0x010
#define um_v                   0x020

//#define SetOpped(x)            (x |= um_o)
//#define SetVoice(x)            (x |= um_v)
#define SetBanned(x)           (x |= cm_b)
#define SetNoColour(x)         (x |= cm_c)
#define SetNoChanCTCP(x)       (x |= cm_C)
#define SetAuditoriumDesync(x) (x |= cm_d)
#define SetAuditorium(x)       (x |= cm_D)
#define SetInviteOnly(x)       (x |= cm_i)
#define SetKey(x)              (x |= cm_k)
#define SetLimit(x)            (x |= cm_l)
#define SetModerated(x)        (x |= cm_m)
#define SetAuthOnlyPrivmsg(x)  (x |= cm_M)
#define SetNoExternal(x)       (x |= cm_n)
#define SetNoChanNotices(x)    (x |= cm_N)
#define SetPrivate(x)          (x |= cm_p)
#define SetAuthedOnly(x)       (x |= cm_r)
#define SetSecure(x)           (x |= cm_s)
#define SetStripCodes(x)       (x |= cm_S)
#define SetOpTopicOnly(x)      (x |= cm_t)
#define SetNoAmsg(x)           (x |= cm_T)
#define SetNoQuitParts(x)      (x |= cm_u)
#define SetSSLOnly(x)          (x |= cm_z)

//#define IsOpped(x)             (x & um_o)
//#define IsVoiced(x)            (x & um_v)
#define IsBanned(x)            (x & cm_b)
#define IsNoColour(x)          (x & cm_c)
#define IsNoChanCTCP(x)        (x & cm_C)
#define IsAuditoriumDesync(x)  (x & cm_d)
#define IsAuditorium(x)        (x & cm_D)
#define IsInviteOnly(x)        (x & cm_i)
#define IsKey(x)               (x & cm_k)
#define IsLimit(x)             (x & cm_l)
#define IsModerated(x)         (x & cm_m)
#define IsAuthOnlyPrivmsg(x)   (x & cm_M)
#define IsNoExternal(x)        (x & cm_n)
#define IsNoChanNotices(x)     (x & cm_N)
#define IsPrivate(x)           (x & cm_p)
#define IsAuthedOnly(x)        (x & cm_r)
#define IsSecure(x)            (x & cm_s)
#define IsStripCodes(x)        (x & cm_S)
#define IsOpTopicOnly(x)       (x & cm_t)
#define IsNoAmsg(x)            (x & cm_T)
#define IsNoQuitParts(x)       (x & cm_u)
#define IsSSLOnly(x)           (x & cm_z)

//#define ClrOpped(x)            (x &= ~um_o)
//#define ClrVoiced(x)           (x &= ~um_v)
#define ClrBanned(x)           (x &= ~cm_b)
#define ClrNoColour(x)         (x &= ~cm_c)
#define ClrNoChanCTCP(x)       (x &= ~cm_C)
#define ClrAuditoriumDesync(x) (x &= ~cm_d)
#define ClrAuditorium(x)       (x &= ~cm_D)
#define ClrInviteOnly(x)       (x &= ~cm_i)
#define ClrKey(x)              (x &= ~cm_k)
#define ClrLimit(x)            (x &= ~cm_l)
#define ClrModerated(x)        (x &= ~cm_m)
#define ClrAuthOnlyPrivmsg(x)  (x &= ~cm_M)
#define ClrNoExternal(x)       (x &= ~cm_n)
#define ClrNoChanNotices(x)    (x &= ~cm_N)
#define ClrPrivate(x)          (x &= ~cm_p)
#define ClrAuthedOnly(x)       (x &= ~cm_r)
#define ClrSecure(x)           (x &= ~cm_s)
#define ClrStripCodes(x)       (x &= ~cm_S)
#define ClrOpTopicOnly(x)      (x &= ~cm_t)
#define ClrNoAmsg(x)           (x &= ~cm_T)
#define ClrNoQuitParts(x)      (x &= ~cm_u)
#define ClrSSLOnly(x)          (x &= ~cm_z)

#define HasMode(x,y)           (x & y)

time_t cf_lastcheck;
chans *cptr(char *name);
cusers *cuptr(char *chan, char *unum);
void adduchan(char *unum, char *chan, time_t created);
void newchannel(char *chan, char *unum, time_t created);
void addcuser(char *chan, char *unum, time_t jts);
void delcuser(char *chan, char *unum);
void setmodes(chans *c, char *modestr);
void setmode(chans *c, char modestr);
void delmode(chans *c, char modestr);
void buildcmodes(chans *c, char *modes);
char *getchanlev(char *chan, char *account);
unsigned int check4cl(char *chan, char *unum, char flag);
unsigned int cl_auto(char *chan, char *unum);
unsigned int cl_banned(char *chan, char *unum);
unsigned int cl_give(char *chan, char *unum);
unsigned int cl_invite(char *chan, char *unum);
unsigned int cl_master(char *chan, char *unum);
unsigned int cl_owner(char *chan, char *unum);
unsigned int cl_op(char *chan, char *unum);
unsigned int cl_deny(char *chan, char *unum);
unsigned int cl_topic(char *chan, char *unum);
unsigned int cl_voice(char *chan, char *unum);
unsigned int cl_welcome(char *chan, char *unum);
unsigned int hascl(char *chan, char *unum);
unsigned int isvalidcl(char flag);
char *getcflags(char *chan);
unsigned int check4cf(char *chan, char flag);
unsigned int isvalidcf(char flag);
unsigned int isvalidcm(char flag);
unsigned int findchannel(char *chan);
int getcid(char *chan);
void getchanbyid(int cid, char *result);
int getusercount(char *chan);
void cf_checkchans();
void cf_checkchan(chans *a);
regops *cf_createregops(chans *a);
int cf_getregopcount(char *chan);
int cf_reop(chans *a);
regops *regopptr(char *chan);
void avg_checkchans();
void avg_makesnapshot(chans *chan, int usercount);
void update_autolimits(void);
void SetOpped(char *ptr);
void SetVoice(char *ptr);
int IsOpped(char *ptr);
int IsVoiced(char *ptr);
void ClrOpped(char *ptr);
void ClrVoiced(char *ptr);

#endif /* _HAVE_CHANNELS */
