/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : config.c, config functions                                  :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_CONFIG
#define _HAVE_CONFIG

#include <stdio.h>
#include <stdlib.h>

#define configfile "conf/modserv.msc"

#define TC_STRING  0
#define TC_INTEGER 1
#define TC_BOOL    2
#define TC_UNKNOWN 3

typedef struct mconfig_t {
  char item[60];
  char val[250];
  char cat[40];
  unsigned int len;
  unsigned int type;
  struct mconfig_t *next;
} mconfig;

mconfig *config_list;

void mconfig_add(char *t, char *c, char *a, char *v);
void mconfig_del(char *item);
char *mconfig_get(char *item, char *def);
void delchar(char *a, char b);
unsigned int mconfig_read();
int mconfig_get_bool(char *item, char *def);
int mconfig_get_integer(char *item, int def);

#endif /* _HAVE_CONFIG */
