/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : dynhdl.h, dynamic handler functions                         :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_DYNHDL
#define _HAVE_DYNHDL

#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>
#include "memstr.h"
#include "clients.h"
#include "strfunc.h"

#define modfile "conf/modserv.msm"

#define stdchl_cmd  40
#define stdchl_mod  40

typedef struct shl_t {
  memstr *token;
  memstr *module;
  void (*func)(void);
  struct shl_t *next;
} shl;

typedef struct chl_t {
  char command[stdchl_cmd];
  char module[stdchl_mod];
  unsigned int desc;
  unsigned int type;
  unsigned int oper;
  unsigned int auth;
  unsigned int active;
  void (*func)(char *arg, char *unum, char *target);
  void *dlptr;
  struct chl_t *next;
} chl;

typedef struct mhl_t {
  memstr *name;
  memstr *desc;
  time_t loadtime;
  void *func;
  struct mhl_t *next;
} mhl;

void shl_add(char *mod, char *tok, void *func);
void shl_del(char *mod, char *tok);
void shl_run(char *tok);
void chl_add(char *mod, char *cmd, void *func, int o, int t, int auth, unsigned int desc);
void chl_del(char *mod, char *cmd, int t);
void chl_run(char *cmd, char *unum, char *target, char *arg, int t);
int loadmod(char *name, char *moddesc);
int loadcommand(char *module, char *cmd, char *oper, char *type);
int unloadcmd(char *module, char *command, int type);
int modstate(char *module);
int unloadmod(char *module);
int setdesc(char *module, char *desc);
int module_autoload();
char *getmodnick(char *mod);
char *getmodsnum(char *mod);
int cmdstate(char *cmd, char *mod);

mhl *mod_list;
chl *cmd_list;
shl *shl_list;

#endif /* _HAVE_DYNHDL */
