/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : lang.h, multi-language features                             :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#ifndef _HAVE_LANG
#define _HAVE_LANG

#include <stdio.h>
#include <stdlib.h>

#define LANG_EN "english"
#define LANG_DE "deutsch"

typedef struct dlang_t {
  char lang[40];
  char val[1024];
  unsigned int item;
  struct dlang_t *next;
} dlang;

typedef struct langlist_t {
  char name[40];
  struct langlist_t *next;
} langlist;

unsigned int loadlang(char *datei, char *lang);
unsigned int addlangitem(int i, char *v, char *l);
void autoload_lang(void);
char *getlang(int item, char *language);
int dellang(char *lang);

dlang *dlang_list;
langlist *lang_list;

#endif /* _HAVE_LANG */
