/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : schedule.h, dynamic scheduler                               :
   : (c) 2004 GamerIRC dev-workx                                 :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#ifndef _HAVE_SCHEDULER
#define _HAVE_SCHEDULER

#include <stdio.h>
#include <stdlib.h>

#define TASK_ONCE 280
#define TASK_PERM 281

typedef struct schedule_t {
  char *module;
  char *desc;
  void (*func)(void);
  time_t lastact;
  int type;
  unsigned int interval;
  unsigned int taskid;
  unsigned long runs;
  struct schedule_t *next;
} schedule;

unsigned int addtask(char *mod, char *desc, unsigned int ival, void *func, int type);
void runtasks(void);
void deltask(unsigned int taskid);
void deltasks(char *modname);
unsigned int gettaskid();

schedule *sched_list;

#endif /* _HAVE_SCHEDULER */
