/**********************************************************
 * ModServ2x - Modular IRC Services for advanced use.     *
 *   Based on the Undernet/Beware P10 Protocol.           *
 *   (C) 2004-2005 Christian Jurk (commx@commx.ws)        *
 *   Special thanks goes to:                              *
 *     Stephan Peijnik                                    *
 *     Linus Kimselius                                    *
 * ------------------------------------------------------ *
 * This program is released under the terms of the GNU    *
 * Public License (GPL). You'll find the License in the   *
 * docs directory shipped with this release.              *
 * ------------------------------------------------------ *
 * trusts.h                                               *
 * Connection count manipulation.                         *
 * 21/06/05 21:16 commx                                   *
 **********************************************************/
 
#ifndef _HAVE_TRUSTS
#define _HAVE_TRUSTS

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdarg.h>
#include <time.h>

#define TG_NAME     60
#define TG_CONTACT  300
#define TG_COMMENT  300
#define TG_ERR_NOID 0

#define IP_LENGTH  16

typedef struct trusts_t {
  char name[TG_NAME];
  char contact[TG_CONTACT];
  char comment[TG_COMMENT];
  char addedby[stddef_authlen];
  unsigned int id;
  unsigned int maxperident;
  unsigned int forceident;
  unsigned int connections;
  time_t expire;
  time_t addedat;
  struct trusts_t *next;
} trustgroup;

typedef struct trusthost_t {
  char addr[IP_LENGTH];
  unsigned int usage;
  unsigned int maxusage;
  time_t lastused;
  trustgroup *trustgroup;
  struct trusthost_t *next;
} trusthost;

trustgroup *tg_list;
trusthost  *th_list;
mBool      trusts_loaded;

trustgroup *istrusted(char *addr, users *u);
trustgroup *gettgbyid(unsigned int id);
trustgroup *gettgbyname(char *name);
void loadtrusts(void);
void savetrusts(void);
unsigned int getnewtgid();
void addtrustgroup(char *na, char *ow, char *ct, char *cm, char *ab, unsigned int mp, unsigned int co, unsigned int fi, time_t ex);
void deltrustgroup(unsigned int id);
unsigned int gettgoc(unsigned int id);
void addtrust(char *addr, unsigned int id);
void deltrust(char *addr, unsigned int id);
unsigned int getucbyhost(char *addr);
unsigned int getcctg(trustgroup *a);

#endif /* _HAVE_TRUSTS */
