/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : ucdata.h                                                    :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_UCDATA
#define _HAVE_UCDATA

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX_MODES 20

typedef struct users_t {
  char nick[stddef_nicklen];
  char ident[stddef_userlen];
  char host[stddef_hostlen];
  char modes[stddef_modelen];
  char auth[stddef_authlen];;
  char unum[stddef_unumlen];
  char hash[stddef_hashlen];
  char lang[stddef_langlen];
  char addr[stddef_addrlen];
  unsigned int using_tg;
  mBool servcli;  
  time_t connected;
  struct users_t *next;
} users;

typedef struct cusers_t {
  char *name;
  char *unum;
  //unsigned int flags;
  char flags[3];
  struct cusers_t *next;
} cusers;

typedef struct regops_t {
  char *chan;
  time_t created;
  time_t lastcheck;
  struct regops_t *next;
} regops;

typedef struct chans_t {
  char name[stdc_name];
  char key[stdc_key];
  char modes[stdc_modes];
  char topic[stdc_topic];
  time_t created;
  unsigned int limit;
  unsigned int cid;
  unsigned long joins;
  unsigned char locked;
  cusers *users;
  regops *regops;
  struct chans_t *next;
} chans;

typedef struct uchans_t {
  char *name;
  char *unum;
  time_t join;
  struct uchans_t *next;
} uchans;

typedef struct myclient_t {
  users *user;
  char module[60];
  struct myclient_t *next;
} myclient;

struct accounts {
  users *user;
  char *uflags;
  struct accounts *next;
};

struct chanlevs {
  users *user;
  char *flags;
  struct chanlevs *next;
};

typedef struct regopu_t {
  regops *regs;
  users *user;
  unsigned int score;
  time_t lastseen;
  struct regopu_t *next;
} regopu;

users *user_list;
chans *chan_list;
cusers *cuser_list;
uchans *uchan_list;
myclient *mycli_list;
regops *regop_list;
regopu *regopu_list;
struct accounts *acc_list;
struct chanlevs *clv_list;

#endif /* _HAVE_UCDATA */
