/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : yalloc.h, custom *alloc functions                           :
   : (c) 2004 Christian Jurk                                     :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */
   
#ifndef _HAVE_YALLOC
#define _HAVE_YALLOC

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

unsigned long bytecounter;

typedef struct yalloc_size_t {
  size_t bytes;
  unsigned int iptr;
  void *mptr;
  struct yalloc_size_t *next;
} yalloc;

yalloc *yalloc_list;
void *myalloc(size_t size_bytes);
void ypcpy(char *target, char *source, int haveptr);
yalloc *yalloc_alloc(unsigned int i, size_t s);
yalloc *yalloc_yptr(unsigned int i);
yalloc *yalloc_free(unsigned int i);
unsigned int yalloc_getid();
char *yalloc_new(size_t s);
char *yalloc_nc(char *str);
void myfree(void *memptr);

#endif /* _HAVE_YALLOC */
