/**********************************************************
 * ModServ2x - Modular IRC Services for advanced use.     *
 *   Based on the Undernet/Beware P10 Protocol.           *
 *   (C) 2004-2005 Christian Jurk (commx@commx.ws)        *
 *   Special thanks goes to:                              *
 *     Stephan Peijnik                                    *
 *     Linus Kimselius                                    *
 * ------------------------------------------------------ *
 * This program is released under the terms of the GNU    *
 * Public License (GPL). You'll find the License in the   *
 * docs directory shipped with this release.              *
 * ------------------------------------------------------ *
 * log.c                                                  *
 * Debugging- and information logsystem.                  *
 * 21/04/05 11:54 commx                                   *
 **********************************************************/
   
#include "include/main.h"
#include "include/log.h"

void slog(char *s, ...) {
  va_list ap; char tmp[1024],tmp2[1024];
  struct tm *tmx; time_t se;
  time(&se);
  /*tmx=localtime(&se);*/  
  va_start(ap,s);
  vsprintf(tmp,s,ap);
  if (dolog == mTrue) {
    fprintf(logfp,"[%ld]: %s\n",(long)time(NULL),tmp);
    fflush(logfp);
  }
  printf("[%ld]: %s\n",(long)time(NULL),tmp);
  va_end(ap);
}

void flog(char *t, char *s, ...) {
  va_list ap; char tmp[1024],tmp2[1024];
  struct tm *tmx; time_t se;
  time(&se);
  /*tmx=localtime(&se);*/
  va_start(ap,s);
  vsprintf(tmp,s,ap);
  if (dolog == mTrue) {
    fprintf(logfp,"[%ld]: (%s()) %s\n",(long)time(NULL),t,tmp);
    fflush(logfp);
  }  
  printf("[%ld]: (%s()) %s",(long)time(NULL),t,tmp);
  va_end(ap);
}

void myprintf(char *s, ...) {
  va_list ap; char tmp[1024];
  struct tm *tmx; time_t se;
  time(&se);
  tmx=localtime(&se);
  va_start(ap,s);
  vsprintf(tmp,s,ap);
  printf("[%02d:%02d:%02d]: %s",tmx->tm_hour,tmx->tm_min,tmx->tm_sec,tmp);
  va_end(ap);
}  

void enable_logging(char *ft) {
  if (ft==NULL) {
    if ((logfp=fopen(std_logfile,"a+"))==NULL) {
      flog("enable_logging","Cannot open logfile '%s' for writing.",std_logfile);
      return;
    }
  } else {
    if ((logfp=fopen(ft,"a+"))==NULL) {
      flog("enable_logging","Cannot open logfile '%s' for writing.",ft);
      return;
    }
  }
  slog("*** Log-System enabled.");
}
