/**********************************************************
 * ModServ2x - Modular IRC Services for advanced use.     *
 *   Based on the Undernet/Beware P10 Protocol.           *
 *   (C) 2004-2005 Christian Jurk (commx@commx.ws)        *
 *   Special thanks goes to:                              *
 *     Stephan Peijnik                                    *
 *     Linus Kimselius                                    *
 * ------------------------------------------------------ *
 * This program is released under the terms of the GNU    *
 * Public License (GPL). You'll find the License in the   *
 * docs directory shipped with this release.              *
 * ------------------------------------------------------ *
 * memstr.c                                               *
 * Memory strings, dstring-like string handling.          *
 * 21/04/05 11:57 commx                                   *
 **********************************************************/

#include "include/memstr.h"

memstr *memstr_new(char *str) {
  memstr *a;
  a=(memstr *)myalloc(sizeof(memstr));
  a->str=(char *)myalloc(strlen(str)+1);
  strncpy(a->str,str,strlen(str));
  a->str[strlen(str)]=0x00;
  a->len=strlen(str);
  return a;
}

memstr *memstr_replace(memstr *c, char *n) {
  free(c->str);
  c->str=(char *)myalloc(strlen(n));
  strncpy(c->str,n,strlen(n));
  c->str[strlen(n)]=0x00;
  c->len=strlen(n);
}

memstr *memstr_free(memstr *c) {
  myfree(c->str);
  myfree(c);
}
