/**********************************************************
 * ModServ2x - Modular IRC Services for advanced use.     *
 *   Based on the Undernet/Beware P10 Protocol.           *
 *   (C) 2004-2005 Christian Jurk (commx@commx.ws)        *
 *   Special thanks goes to:                              *
 *     Stephan Peijnik                                    *
 *     Linus Kimselius                                    *
 * ------------------------------------------------------ *
 * This program is released under the terms of the GNU    *
 * Public License (GPL). You'll find the License in the   *
 * docs directory shipped with this release.              *
 * ------------------------------------------------------ *
 * modbas.c                                               *
 * Module-based, global functions.                        *
 * 21/04/05 11:58 commx                                   *
 **********************************************************/

#include "include/main.h"
#include "include/modbas.h"
#include "include/strfunc.h"

void m_privmsg(char *unum, char *sender, char *msg, ...) {
  va_list ap; char tmpa[530];
  va_start(ap,msg);
  vsnprintf(tmpa,modserv_bufsize,msg,ap);
  send2up("%s P %s :%s",sender,unum,msg);
  va_end(ap);
}

void m_notice(char *unum, char *sender, char *msg, ...) {
  va_list ap; char tmpa[530];
  va_start(ap,msg);
  vsnprintf(tmpa,modserv_bufsize,msg,ap);
  send2up("%s O %s :%s",sender,unum,tmpa);
  printf("%s O %s :%s\n",sender,unum,tmpa);
  va_end(ap);
}

void m_mode(char *sender, char *target, char *modestr, ...) {
  va_list ap; char tmpa[530];
  va_start(ap,modestr);
  vsnprintf(tmpa,modserv_bufsize,modestr,ap);
  send2up("%s M %s %s",sender,target,tmpa);
  va_end(ap);
}

void strarray(char *arg) {
  char *p; cargc=0; unsigned int i;
  for(i=0;i<max_cmdargs;i++) {
    cargs[i][0]=0x00;
  }
  p=(char*)strtok(arg," ");
  if (p!=NULL) {
    strcpy(cargs[cargc],p);
    cargs[cargc][strlen(p)]=0x00;
  }
  for(;(p=(char*)strtok(NULL," "))!=NULL;) {
    strcpy(cargs[cargc++],p);
    cargs[cargc][strlen(p)]=0x00;
  }
}

mBool SendPriv(char *unum) {
  char *tmpauth;
  if (!isauthed(unum)) {
    return mFalse;
  } else {
    tmpauth=getauth(unum);
    assert(tmpauth);
    if (hasuflag(tmpauth,'p')) {
      return mTrue;
    } else {
      return mFalse;
    }
  }
}
