/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : cservice.c, channel services                                :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "clients.h"
#include "configx.h"
#include "ucdata.h"
#include "channels.h"
#include "pgsql.h"
#include "schedule.h"
#include "account.h"

#define module_name  "cservice"
#define module_desc  "Channel and Account management service"
#define module_nick  mconfig_get("cs_nick","G2")
#define module_ident mconfig_get("cs_ident","cservice")
#define module_host  mconfig_get("cs_host","channels.gamerirc")
#define module_modes mconfig_get("cs_modes","+kr")
#define module_auth  mconfig_get_bool("cs_auth","true")
#define module_real  mconfig_get("cs_real","ModServ 2.0 Channel Service")

void kill_expired_bans() {
  PGresult *res,*res2; int i;
  res=pg_query("SELECT cid,hostmask FROM bans WHERE expirets<%ld;",time(NULL));
  for(i=0;i<pg_num_rows(res);i++) {
    res2=pg_query("SELECT channel FROM channels WHERE cid=%ld;",atol(PQgetvalue(res,i,0)));
    send2up("%s M %s -b %s",getmodsnum("cservice"),PQgetvalue(res2,0,0),PQgetvalue(res,i,1));
    PQclear(res2);
  }
  pg_query("DELETE FROM bans WHERE expirets<%ld;",time(NULL));
  PQclear(res);
}

void clearsuspends() {
  PGresult *res; int i=0; time_t nex; char tmpacc[40];
  res=pg_query("SELECT uid FROM accountsuspends WHERE expirets<%ld;",time(NULL));
  if (pg_num_rows(res)>0) {
    for(i=0;i<pg_num_rows(res);i++) {
      pg_query("UPDATE users SET suspended=FALSE WHERE uid=%s;",PQgetvalue(res,i,0));
    }
  }
  pg_query("DELETE FROM accountsuspends WHERE expirets<%ld",time(NULL));
  if (global_debug && i>0) flog("clearsuspends", "Cleared %d account suspensions",i);
  PQclear(res);
  /* What about expired accounts? */
  nex=time(NULL)-account_expiretime;
  res=pg_query("SELECT uid,account FROM users WHERE lastauth<%ld AND lastauth!='0';",nex);
  if (pg_num_rows(res)>0) {
    for(i=0;i<pg_num_rows(res);i++) {
      resetchar(tmpacc);
      strcp(tmpacc,PQgetvalue(res,i,1));
      strtolower(tmpacc);
      pg_query("DELETE FROM chanlevs,users WHERE lower(account)='%s';",tmpacc);
      pg_query("DELETE FROM vhosts,accountsuspends WHERE uid=%ld;",atol(PQgetvalue(res,i,0)));
    }
  }
}

void cservice_shl_mode(void) {
  char *cf; int i,d,b=4; PGresult *res; chans *a;
  if (findchannel(args[2])) {
    cf=getcflags(args[2]);
    if (cf==NULL) {
      return;
    }
    for(i=0;i<strlen(args[3]);i++) {
      if (args[3][i]=='+') { d=1; continue; }
      if (args[3][i]=='-') { d=0; continue; }
      if (d==0) {
        if (args[3][i]=='k') {
          if (chrstr('k',cf)) {
            strtolower(args[2]);
            res=pg_query("SELECT ckey FROM channels WHERE lower(channel)='%s'",args[2]);
            if (pg_num_rows(res)<1) {
              PQclear(res);
              continue;
            }
            if (PQgetvalue(res,0,0)==NULL) {
              PQclear(res);
              continue;
            }
            send2up("%s M %s +k %s",getmodsnum(module_name),args[2],PQgetvalue(res,0,0));
            a=cptr(args[2]);
            if (a!=NULL) {
              appchar(a->modes,'k');
              strsortn(a->modes);
            }
            PQclear(res);
            continue;
          }
        }
        if (args[3][i]=='o') {
          if (chrstr('p',cf)) {
            if (isauthed(args[b])) {
              if (cl_op(args[2],args[b]) || cl_master(args[2],args[b]) || cl_owner(args[2],args[b])) {
                send2up("%s M %s +o %s",getmodsnum(module_name),args[2],args[b]);
              }
            }
          }
          b++;
          continue;
        }
        if (args[3][i]=='v') {
          if (chrstr('p',cf)) {
            if (isauthed(args[b])) {
              if (cl_op(args[2],args[b]) || cl_voice(args[2],args[b]) || cl_master(args[2],args[b]) || cl_owner(args[2],args[b])) {
                send2up("%s M %s +v %s",getmodsnum(module_name),args[2],args[b]);
              }
            }
          }
          b++;
          continue;
        }        
      }
      if (d==1) {
        if (args[3][i]=='o') {
          if (chrstr('b',cf)) {
            if (!isauthed(args[b]) && !cl_op(args[2],args[b]) && !cl_master(args[2],args[b]) && !cl_owner(args[2],args[b])) {
              send2up("%s M %s -o %s",getmodsnum(module_name),args[2],args[b]);
            }
          }
          b++;
          continue;
        }
        if (args[3][i]=='v') {
          if (chrstr('b',cf)) {
            if (!isauthed(args[b]) && !cl_op(args[2],args[b]) && !cl_voice(args[2],args[b]) && !cl_master(args[2],args[b]) && !cl_owner(args[2],args[b])) {
              send2up("%s M %s -v %s",getmodsnum(module_name),args[2],args[b]);
            }
          }
          b++;
          continue;
        }         
      }
    }
    free(cf);
  }
}

void cservice_shl_join(void) {
  char flags[20],sets[10],newmask[512]; PGresult *res; int cid,i; char *cflags; cusers *c; users *a;
  if (findchannel(args[2])) {
    cid=getcid(args[2]);
    cflags=getcflags(args[2]);
    strcpy(flags,"");
    strcpy(sets,"+");
    // check for flag-ban first
    if (hascl(args[2],args[0]) && cl_banned(args[2],args[0])) {
      if ((a=uptr(args[0]))!=NULL) {
        send2up("%s M %s +b *!%s@%s",getmodsnum(module_name),args[2],a->ident,a->host);
      }
      send2up("%s K %s %s :%s",getmodsnum(module_name),args[2],args[0],getlang(2013,gu(args[0],1)));
      delcuser(args[2],args[0]);
      return;
      free(cflags);
    }
    if (cflags!=NULL && strchr(cflags,'w')) {
      if (!cl_welcome(args[2],args[0])) {
        // welcome message
        res=pg_query("SELECT message FROM greetings WHERE cid=%d",cid);
        if (pg_num_rows(res)>0) {
          m_notice(args[0],nick2num(module_nick),"[%s]: %s",args[2],PQgetvalue(res,0,0));
        }
        PQclear(res);
      }
    }
    resetchar(flags);
    if (cflags!=NULL && strchr(cflags,'a')) {
      // check for master/owner/op access
      if (hascl(args[2],args[0]) && cl_op(args[2],args[0]) || cl_master(args[2],args[0]) || cl_owner(args[2],args[0])) {
        m_mode(nick2num(module_nick),args[2],"+o %s",args[0]);
        if ((c=cuptr(args[2],args[0]))!=NULL && !IsOpped(c->flags)) {
          SetOpped(c->flags);
        }
      }
    }
    if (cflags!=NULL && strchr(cflags,'o')) {
      // op the user
      m_mode(nick2num(module_nick),args[2],"+o %s",args[0]);
      if ((c=cuptr(args[2],args[0]))!=NULL && !IsOpped(c->flags)) {
        SetOpped(c->flags);
      }
    }
    if (cflags!=NULL && strchr(cflags,'v')) {
      // voice the user
      m_mode(nick2num(module_nick),args[2],"+v %s",args[0]);
      if ((c=cuptr(args[2],args[0]))!=NULL && !IsVoiced(c->flags)) {
        SetVoice(c->flags);
      }
    }      
    if (hascl(args[2],args[0]) && !cl_deny(args[2],args[0])) {
      if (cl_op(args[2],args[0])) {
        strcat(flags,args[0]);
        strcat(flags," ");
        strcat(sets,"o");
        if ((c=cuptr(args[2],args[0]))!=NULL && !IsOpped(c->flags)) {
          SetOpped(c->flags);
        }        
      } else if (cl_voice(args[2],args[0])) {
        strcat(flags,args[0]);
        strcat(flags," ");
        strcat(sets,"v");
        if ((c=cuptr(args[2],args[0]))!=NULL && !IsVoiced(c->flags)) {
          SetVoice(c->flags);
        }        
      }
      m_mode(nick2num(module_nick),args[2],"%s %s",sets,flags);
    }
    if (cflags!=NULL && !strchr(cflags,'e')) {
      // checking for bans
      res=pg_query("SELECT hostmask,breason FROM bans WHERE cid=%d",cid);
      if (pg_num_rows(res)>0) {
        for(i=0;i<pg_num_rows(res);i++) {
          for(c=cuser_list;c!=NULL;c=c->next) {
            if (c->name!=NULL && !strcasecmp(c->name,args[2])) {
              if ((a=uptr(a->unum))!=NULL) {
                sprintf(newmask,"%s!%s@%s",a->nick,a->ident,a->host);
                if (strmatch(PQgetvalue(res,i,0),newmask)) {
                  // user match, ban him!
                  send2up("%s M %s +b %s",getmodsnum(module_name),args[2],PQgetvalue(res,i,0));
                  send2up("%s K %s %s :%s",getmodsnum(module_name),args[2],a->unum,PQgetvalue(res,i,1));
                  delcuser(args[2],a->unum);
                }
              }
            }
          }
        }
      }
    }
    free(cflags);
  }
}

void cservice_shl_topic(void) {
  /* AB T #chan 1020434 102372 :topic is here */
  int i=3; chans *c; char topic[stdc_topic+1];
  if (!check4cf(args[2],'t') || !have_eob) return;
  if (isauthed(args[0])) {
	if (cl_master(args[2],args[0]) || cl_master(args[2],args[0])) {
	  return;
	}
  }
  c=cptr(args[2]);
  if (c==NULL) return; 
  if (c->topic && c->topic[0]!='\0') {
    c->locked=1;	  
    send2up("%s T %s %ld %ld :%s",getmodsnum(module_name),args[2],c->created,time(NULL),c->topic);
  }
}

void cservice_init(void) {
  PGresult *res; unsigned int i,j;
  client_create(module_name,module_nick,module_ident,module_host,module_modes,module_auth,module_real);
  if (!mconfig_get_bool("cs_joinchans","true")) return;
  res=pg_query("SELECT channel FROM channels WHERE suspended=FALSE");
  if (!res) {
    slog("** PgSQL: Select * from channels failed!");
    PQclear(res);
    return;
  }
  for(i=0;i<pg_num_rows(res);i++) {
    if (PQgetvalue(res,i,0)==NULL) continue;
    client_join(module_nick,PQgetvalue(res,i,0));
  }
  PQclear(res);
  slog("** cservice: Joined %d %s",i,(i>1) ? "channels" : "channel");
  shl_add(module_name,"J",cservice_shl_join);
  shl_add(module_name,"M",cservice_shl_mode);
  shl_add(module_name,"T",cservice_shl_topic);
  addtask(module_name,"Updates the autolimits",60,update_autolimits,TASK_PERM);
  addtask(module_name,"Kills expired bans",10,kill_expired_bans,TASK_PERM);
  addtask(module_name,"Removes expired accounts(-uspends)",10,clearsuspends,TASK_PERM);
}

void cservice_close(void) {
  client_close(module_nick,"cservice closed.");
  shl_del(module_name,"J");
  shl_del(module_name,"M");
  shl_del(module_name,"T");
  deltasks(module_name);
}
