/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : addchan.c - Adds the channel service to a channel.          :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "dynhdl.h"

#define command_module "cservice"
#define command_name   "addchan"
#define command_desc   2014
#define command_oper   0
#define command_type   1
#define command_auth   1

unsigned int findchannel(char *chan) {
  PGresult *res;
  strtolower(chan);
  res=pg_query("SELECT * FROM channels WHERE lower(channel)='%s'",chan);
  if (!res) {
    PQclear(res);
    return 0;
  }
  if (PQntuples(res)<1) {
    PQclear(res);
    return 0;
  } else {
    PQclear(res);
    return 1;
  }
}

void cservice_cmd_addchan(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char acc[40];
  if (mconfig_get_bool("sa_power","true")) {
    if (!isoper(unum) && (is_sa(getauth(unum)) == mFalse)) {
      m_notice(unum,target,getlang(8202,gu(unum,1)));
      return;
    }
  } else {
    if (!isoper(unum)) {
      m_notice(unum,target,getlang(8202,gu(unum,1)));
      return;
    }
  }
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2015,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2016,gu(unum,1)));
    m_notice(unum,target,getlang(2017,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (cargs[1][0]=='#') {
    sprintf(acc,"%s",cargs[1]+1);
    strtolower(acc);
    res=pg_query("SELECT account FROM users WHERE lower(account)='%s';",acc);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(8211,gu(unum,1)),acc);
      PQclear(res);
      return;
    }
    strcpy(acc,PQgetvalue(res,0,0));
    PQclear(res);
  } else {
    if ((char*)getauth((char*)nick2num(cargs[1]))==NULL) {
      m_notice(unum,target,getlang(2018,gu(unum,1)),cargs[1]);
      return;
    }
    strcpy(acc,(char*)getauth((char*)nick2num(cargs[1])));
  }
  if (findchannel(cargs[0])) {
    m_notice(unum,target,getlang(2019,gu(unum,1)),cargs[0]);
    return;
  }
  pg_query("INSERT INTO channels (channel,regtime,suspended,joincount,cid,flags) VALUES ('%s','%ld',FALSE,0,nextval('inc_cid'),'+');",cargs[0],time(NULL));
  pg_query("INSERT INTO chanlevs (cid,account,flags) VALUES (%d,'%s','+amno');",getcid(cargs[0]),acc);
  strtolower(cargs[0]);
  res=pg_query("SELECT cid FROM channels WHERE lower(channel)='%s';",cargs[0]);
  if (!res) {
    slog("** SQL-ERROR: query returned 0 (cservice::addchan)!");
    PQclear(res);
    return;
  }
  if (pg_num_rows(res)<1) {
    slog("** SQL-ERROR: pg_num_rows() returned <1!");
    PQclear(res);
    return;
  }
  client_join(getmodnick(command_module),cargs[0]);
  m_notice(unum,target,getlang(2020,gu(unum,1)),PQgetvalue(res,0,0));
}

void load_cservice_cmd_addchan(void) {
  chl_add(command_module,command_name,cservice_cmd_addchan,command_oper,command_type,command_auth,command_desc);
}
