/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : autolimit.c                                                 :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "channels.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "autolimit"
#define command_desc   2355
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_autolimit(char *arg, char *unum, char *target) {
  strarray(arg); unsigned int i,val=0; PGresult *res; chans *c;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2356,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    m_notice(unum,target,getlang(2357,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(8202,gu(unum,1)));
    return;
  }
  c=cptr(cargs[0]);
  if (c==NULL) {
    return;
  }
  if (cargc==1) {
    strtolower(cargs[0]);
    res=pg_query("SELECT autolimit FROM channels WHERE lower(channel)='%s';",cargs[0]);
    if (pg_num_rows(res)<1) {
      PQclear(res);
      return;
    }
    if (PQgetvalue(res,0,0)==NULL) {
      val=0;
    } else {
      val=atoi(PQgetvalue(res,0,0));
    }
    if (val==0) {
      m_notice(unum,target,getlang(2420,gu(unum,1)));
      PQclear(res);
      return;
    }
    m_notice(unum,target,getlang(2361,gu(unum,1)),cargs[0],val);
    PQclear(res);
    return;
  }
  val=atoi(cargs[1]);
  if (val==0) {
    m_notice(unum,target,getlang(2358,gu(unum,1)));
    return;
  }
  if (val>=1000) {
    m_notice(unum,target,getlang(2359,gu(unum,1)));
    return;
  }
  strtolower(cargs[0]);
  pg_query("UPDATE channels SET autolimit=%d WHERE lower(channel)='%s';",val,cargs[0]);
  m_notice(unum,target,getlang(2360,gu(unum,1)),val);  
  val+=getusercount(cargs[0]);
  send2up("%s M %s +l %d",getmodsnum(command_module),cargs[0],val);
  if (!chrstr('l',c->modes)) {
    appchar(c->modes,'l');
    strsortn(c->modes);
  }
}

void load_cservice_cmd_autolimit(void) {
  chl_add(command_module,command_name,cservice_cmd_autolimit,command_oper,command_type,command_auth,command_desc);
}
