/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : ban.c                                                       :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"
#include "schedule.h"

#define command_module "cservice"
#define command_name   "ban"
#define command_desc   2035
#define command_oper   0
#define command_type   1
#define command_auth   1

void revoke_ban(char *chan, char *mask) {
  strtolower(chan);
  pg_query("DELETE FROM bans WHERE lower(channel)='%s' AND mask~*'%s';",chan,mask);
  send2up("%s M %s -b %s",getmodsnum(command_module),chan,mask);
}

void cservice_cmd_ban(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char masktoban[512],newmask[512],the_reason[512],dura[60],tmpdesc[512];
  cusers *a; users *b; int users_affected=0,i,cid; long duration_in_secs=0; time_t tx;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2036,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2037,gu(unum,1)));
    m_notice(unum,target,getlang(2038,gu(unum,1)));
    m_notice(unum,target,getlang(2039,gu(unum,1)));
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2040,gu(unum,1)));
    m_notice(unum,target,getlang(2041,gu(unum,1)));
    return;
  } else if (cargc<3) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2043,gu(unum,1)));
    return;
  }
  cid=getcid(cargs[0]);
  resetchar(masktoban);
  if (chrstr('@',cargs[1])) {
    // mask ban
    if (!strcmp(cargs[1],"*@*") || !strcmp(cargs[1],"*!*@*")) {
      m_notice(unum,target,getlang(2044,gu(unum,1)));
      return;
    }
    strncpy(masktoban,cargs[1],strlen(cargs[1]));
    masktoban[strlen(cargs[1])]=0x00;
  } else {
    // nick ban
    if ((char*)nick2num(cargs[1])==NULL) {
      m_notice(unum,target,getlang(8213,gu(unum,1)),cargs[1]);
      return;
    }
    sprintf(masktoban,"%s!*@*",cargs[1]);
  }
  if ((duration_in_secs=duration2long(cargs[2]))<0) {
    m_notice(unum,target,getlang(2045,gu(unum,1)));
    return;
  }
  resetchar(the_reason);
  if (cargc>=4) {
    for(i=3;(cargs[i][0]);i++) {
      if (cargs[i][0]=='\0') continue;
      strcat(the_reason,cargs[i]);
      if (cargs[i+1]) strcat(the_reason," ");
    }
  } else {
    strcpy(the_reason,getlang(2046,gu(unum,1)));
  }
  send2up("%s M %s +b %s",getmodsnum(command_module),cargs[0],masktoban);
  for(a=cuser_list;a!=NULL;a=a->next) {
    if (!strcasecmp(a->name,cargs[0])) {
      b=uptr(a->unum);
      if (b==NULL) continue;
      // write some full-mask to compare with the pattern matcher
      sprintf(newmask,"%s!%s@%s",b->nick,b->ident,b->host);
      if (strmatch(masktoban,newmask)) {
        // mask matched, kick the user off the channel
        resetchar(dura);
        durationcp(duration_in_secs,dura);
        send2up("%s K %s %s :Banned: %s (%s)",getmodsnum(command_module),a->name,a->unum,the_reason,dura);
        delcuser(a->name,a->unum);
        users_affected++;
      }
    }
  }
  the_reason[strlen(the_reason)-1]=0x00;
  tx=((time_t)time(NULL)+(time_t)duration_in_secs);
  pg_query("INSERT INTO bans (cid,hostmask,expirets,banby,banat,breason) VALUES (%d,'%s','%ld','%s','%ld','%s');",cid,masktoban,tx,num2nick(unum),time(NULL),the_reason);
  m_notice(unum,target,getlang(2047,gu(unum,1)),masktoban,users_affected,(users_affected==1) ? "" : "s");
  m_notice(unum,target,getlang(2048,gu(unum,1)),cctime(tx),the_reason);
}

void load_cservice_cmd_ban(void) {
  chl_add(command_module,command_name,cservice_cmd_ban,command_oper,command_type,command_auth,command_desc);
}
