/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : chanflags.c - Manages channel customizing flags.            :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "chanflags"
#define command_desc   2057
#define command_oper   0
#define command_type   1
#define command_auth   1

unsigned int findchannel(char *chan) {
  PGresult *res;
  strtolower(chan);
  res=pg_query("SELECT * FROM channels WHERE lower(channel)='%s';",chan);
  if (!res) {
    PQclear(res);
    return 0;
  }
  if (PQntuples(res)<1) {
    PQclear(res);
    return 0;
  } else {
    PQclear(res);
    return 1;
  }
}

void cservice_cmd_chanflags(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char *h; char tmp[20]; unsigned int i,j,a=0,b=0; int cid;
  chans *c;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(2057,gu(unum,1)));
    m_notice(unum,target,getlang(2058,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2059,gu(unum,1)));
    m_notice(unum,target,getlang(2060,gu(unum,1)));
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2061,gu(unum,1)));
    m_notice(unum,target,getlang(2062,gu(unum,1)));
    m_notice(unum,target,getlang(2063,gu(unum,1)));
    m_notice(unum,target,getlang(2064,gu(unum,1)));
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2065,gu(unum,1)));
    m_notice(unum,target,getlang(2066,gu(unum,1)));
    m_notice(unum,target,getlang(2067,gu(unum,1)));
    m_notice(unum,target,getlang(2068,gu(unum,1)));
    m_notice(unum,target,getlang(2069,gu(unum,1)));
    m_notice(unum,target,getlang(2377,gu(unum,1)));
    m_notice(unum,target,getlang(2070,gu(unum,1)));
    m_notice(unum,target,getlang(2071,gu(unum,1)));
    m_notice(unum,target,getlang(2072,gu(unum,1)));
    m_notice(unum,target,getlang(2073,gu(unum,1)));
    m_notice(unum,target,getlang(2074,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }  
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2075,gu(unum,1)));
    return;
  }
  cid=getcid(cargs[0]);
  if (cargc==1) {
    // displaying flags
    res=pg_query("SELECT channel,flags FROM channels WHERE cid=%d;",cid);
    if (!res || (pg_num_rows(res)<1)) {
      m_notice(unum,target,getlang(2076,gu(unum,1)));
      PQclear(res);
      return;
    }
    h=PQgetvalue(res,0,1);
    if (h==NULL || !strcmp(h,"+")) {
      m_notice(unum,target,getlang(2077,gu(unum,1)));
      PQclear(res);
      return;
    }
    m_notice(unum,target,getlang(2078,gu(unum,1)),PQgetvalue(res,0,0),(h[0]!='+') ? "+" : "",h);
    PQclear(res);
    return;
  } else {
    // setting flags
    h=getcflags(cargs[0]);
    if (h==NULL) {
      resetchar(tmp);
      strcpy(tmp,"+");
    } else {
      strcpy(tmp,h);
    }
    h[strlen(h)]=0x00;
    j=0;
    for(i=0;i<strlen(cargs[1]);i++) {
      if (cargs[1][i]=='+') { j=1; continue; }
      if (cargs[1][i]=='-') { j=2; continue; }
      if (!isvalidcf(cargs[1][i])) {
        m_notice(unum,target,getlang(2079,gu(unum,1)),cargs[1][i]);
        continue;
      }
      if (j==1) {
        // adding flags
        if (!chrstr(cargs[1][i],tmp)) {
          appchar(tmp,cargs[1][i]); a++;
        }
      } else if (j==2) {
        // removing flags
        if (chrstr(cargs[1][i],tmp)) {        
          delchar(tmp,cargs[1][i]); b++;
        }
		if (cargs[1][i]=='c') {
		  /* if 'c' is removed, unset the mode +l */
		  c=cptr(cargs[0]);
		  if (c!=NULL) {
			if (c->modes && chrstr('l',c->modes))
		      send2up("%s OM %s -l",getmodsnum(command_module),c->name);
		  }
	    }
      } else {
        m_notice(unum,target,getlang(2080,gu(unum,1)),cargs[1][i]);
        continue;
      }
    }
    strsort(tmp);
    pg_query("UPDATE channels SET flags='%s' WHERE cid=%d;",tmp,cid);
    m_notice(unum,target,getlang(2081,gu(unum,1)),a,(a==1) ? "" : "s",b,(b==1) ? "" : "s");
    free(h);
    return;
  }
}

void load_cservice_cmd_chanflags(void) {
  chl_add(command_module,command_name,cservice_cmd_chanflags,command_oper,command_type,command_auth,command_desc);
}
