/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : chanstats.c - Displays channel statistics.                  :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "chanstats"
#define command_desc   2131
#define command_oper   1
#define command_type   1
#define command_auth   1

unsigned int findchannel(char *chan) {
  PGresult *res;
  res=pg_query("Select * from channels WHERE channel~*'%s';",chan);
  if (!res) {
    PQclear(res);
    return 0;
  }
  if (PQntuples(res)<1) {
    PQclear(res);
    return 0;
  } else {
    PQclear(res);
    return 1;
  }
}

void cservice_cmd_chanstats(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; unsigned int c=0; float d; time_t e; char *f; chans *g; char cm[40];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2132,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8216,gu(unum,1)),cargs[0]);
    return;
  }
  res=pg_query("SELECT channel,suspended,joincount,cid,regtime FROM channels WHERE channel~*'%s';",cargs[0]);
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(8217,gu(unum,1)));
    PQclear(res);
    return;
  }
  g=cptr(cargs[0]);  
  d=atol(PQgetvalue(res,0,4));
  d=time(NULL)-d;
  d=(3600*24)/d;
  e=atol(PQgetvalue(res,0,4));
  f=PQgetvalue(res,0,1);
  m_notice(unum,target,getlang(2134,gu(unum,1)),PQgetvalue(res,0,0));
  m_notice(unum,target,getlang(2135,gu(unum,1)),(f[0]=='f') ? getlang(8205,gu(unum,1)) : getlang(8204,gu(unum,1)));
  if (atol(PQgetvalue(res,0,2))>0) {
    m_notice(unum,target,getlang(2136,gu(unum,1)),atol(PQgetvalue(res,0,2)),d);
  } else {
    m_notice(unum,target,getlang(2137,gu(unum,1)),PQgetvalue(res,0,2));  
  }
  m_notice(unum,target,getlang(2138,gu(unum,1)),PQgetvalue(res,0,3));
  m_notice(unum,target,getlang(2139,gu(unum,1)),ctime(&e),PQgetvalue(res,0,4));
  if (g!=NULL) {
    printf("g!=NULL!\n");
    buildcmodes(g,cm);
    if (strlen(cm)>0) {
      m_notice(unum,target,getlang(2140,gu(unum,1)),cm);
    }
  } else {
    printf("g==NULL!\n");
  }
}

void load_cservice_cmd_chanstats(void) {
  chl_add(command_module,command_name,cservice_cmd_chanstats,command_oper,command_type,command_auth,command_desc);
}
