/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : cmode.c                                                     :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "cmode"
#define command_desc   2390
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_cmode(char *arg, char *unum, char *target) {
  strarray(arg); chans *c; int i,d=0,b=2,a1=0,a2=0,a3=0; char oldmodes[40];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2391,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2084,gu(unum,1)));
    m_notice(unum,target,getlang(2392,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2043,gu(unum,1)));
    return;
  }
  if (cargc<2) {
    /* just display the channel modes */
    c=cptr(cargs[0]);
    if (c==NULL) {
      m_notice(unum,target,getlang(8219,gu(unum,1)));
      return;
    }
    if (!c->modes || c->modes==NULL || (c->modes[0]=='+' && strlen(c->modes)==1)) {
      m_notice(unum,target,getlang(2393,gu(unum,1)),c->name);
      return;
    }
    m_notice(unum,target,getlang(2394,gu(unum,1)),c->name,(c->modes[0]!='+') ? "+" : "",c->modes);
    return;
  } else {
    c=cptr(cargs[0]);
    if (c==NULL) {
      m_notice(unum,target,getlang(8219,gu(unum,1)));
      return;
    }
    resetchar(oldmodes);
    for(i=0;i<strlen(cargs[1]);i++) {
      if (cargs[1][i]=='+') { d=1; continue; }
      if (cargs[1][i]=='-') { d=2; continue; }
      if (cargs[1][i]=='?') { d=3; continue; }
      if (d == 1) {
        /* adding channel modes */
        if (!isvalidcm(cargs[1][i])) {
          m_notice(unum,target,getlang(2395,gu(unum,1)),cargs[1][i]);
          continue;
        }
        if (!chrstr(cargs[1][i],c->modes)) {
          appchar(c->modes,cargs[1][i]);
          a1++;
        }
        if (cargs[1][i]=='b' || cargs[1][i]=='d' || cargs[1][i]=='o' || cargs[1][i]=='v') {
          continue;
        }
        if (cargs[1][i]=='c' && chrstr('S',c->modes)) {
          delchar(c->modes,'S');
          appchar(c->modes,'c');
          continue;
        }
        if (cargs[1][i]=='S' && chrstr('c',c->modes)) {
          delchar(c->modes,'c');
          appchar(c->modes,'S');
          continue;
        }        
        if (cargs[1][i]=='k' && cargs[b]) {
          strcp(c->key,cargs[b]);
          b++;
        }
        if (cargs[1][i]=='l' && cargs[b]) {
          c->limit=atoi(cargs[b]);
          b++;
        }        
        continue;
      }
      if (d == 2) {
        /* revoking channel modes */
        if (!isvalidcm(cargs[1][i])) {
          m_notice(unum,target,getlang(2395,gu(unum,1)),cargs[1][i]);
          continue;
        }
        if (chrstr(cargs[1][i],c->modes)) {
          delchar(c->modes,cargs[1][i]);
          a2++;
        }
        if (cargs[1][i]=='b' || cargs[1][i]=='d' || cargs[1][i]=='o' || cargs[1][i]=='v') {
          continue;
        }        
        if (cargs[1][i]=='k') {
          resetchar(c->key);
        }
        if (cargs[1][i]=='l') {
          c->limit=0;
        }
        appchar(oldmodes,cargs[1][i]);
        continue;
      }
      if (d == 3) {
        /* info of channel modes */
        if (!isvalidcm(cargs[1][i])) {
          m_notice(unum,target,getlang(2395,gu(unum,1)),cargs[1][i]);
          continue;
        }
        switch(cargs[1][i]) {
          case 'b': m_notice(unum,target,getlang(2396,gu(unum,1))); break;
          case 'c': m_notice(unum,target,getlang(2397,gu(unum,1))); break;
          case 'C': m_notice(unum,target,getlang(2398,gu(unum,1))); break;
          case 'd': m_notice(unum,target,getlang(2399,gu(unum,1))); break;
          case 'D': m_notice(unum,target,getlang(2400,gu(unum,1))); break;
          case 'i': m_notice(unum,target,getlang(2401,gu(unum,1))); break;
          case 'k': m_notice(unum,target,getlang(2402,gu(unum,1))); break;
          case 'l': m_notice(unum,target,getlang(2403,gu(unum,1))); break;
          case 'm': m_notice(unum,target,getlang(2404,gu(unum,1))); break;
          case 'M': m_notice(unum,target,getlang(2405,gu(unum,1))); break;
          case 'n': m_notice(unum,target,getlang(2406,gu(unum,1))); break;
          case 'N': m_notice(unum,target,getlang(2407,gu(unum,1))); break;
          case 'o': m_notice(unum,target,getlang(2408,gu(unum,1))); break;
          case 'p': m_notice(unum,target,getlang(2409,gu(unum,1))); break;
          case 'r': m_notice(unum,target,getlang(2410,gu(unum,1))); break;
          case 's': m_notice(unum,target,getlang(2411,gu(unum,1))); break;
          case 'S': m_notice(unum,target,getlang(2412,gu(unum,1))); break;
          case 't': m_notice(unum,target,getlang(2413,gu(unum,1))); break;
          case 'T': m_notice(unum,target,getlang(2414,gu(unum,1))); break;
          case 'u': m_notice(unum,target,getlang(2415,gu(unum,1))); break;
          case 'v': m_notice(unum,target,getlang(2416,gu(unum,1))); break;
          case 'z': m_notice(unum,target,getlang(2417,gu(unum,1))); break;
        }
        a3++;
        continue;
      }
    }
  }
  strsortn(c->modes);
  if (a2>0) {
    send2up("%s M %s -%s",getmodsnum(command_module),c->name,oldmodes);
  }
  send2up("%s M %s %s",getmodsnum(command_module),c->name,c->modes);
  if ((a1>0 || a2>0) && a3<1) {
    m_notice(unum,target,getlang(2418,gu(unum,1)),c->modes,a1,a2);
  }
}

void load_cservice_cmd_cmode(void) {
  chl_add(command_module,command_name,cservice_cmd_cmode,command_oper,command_type,command_auth,command_desc);
}
