/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : delchan.c - Removes the channel service from a channel.     :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "clients.h"
#include "channels.h"
#include "dynhdl.h"

#define command_module "cservice"
#define command_name   "delchan"
#define command_desc   2141
#define command_oper   1
#define command_type   1
#define command_auth   1

unsigned int findchannel(char *chan) {
  PGresult *res;
  strtolower(chan);
  res=pg_query("SELECT * FROM channels WHERE lower(channel)='%s';",chan);
  if (!res) {
    PQclear(res);
    return 0;
  }
  if (PQntuples(res)<1) {
    PQclear(res);
    return 0;
  } else {
    PQclear(res);
    return 1;
  }
}

void cservice_cmd_delchan(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; unsigned int c=0;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2142,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2143,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8216,gu(unum,1)),cargs[0]);
    return;
  }
  strtolower(cargs[0]);
  pg_query("DELETE FROM channels WHERE lower(channel)='%s';",cargs[0]);
  res=pg_query("SELECT account FROM chanlevs WHERE lower(channel)='%s';",cargs[0]);
  c=pg_num_rows(res);
  pg_query("DELETE FROM chanlevs WHERE lower(channel)='%s';",cargs[0]);
  client_part(getmodnick(command_module),cargs[0]);
  m_notice(unum,target,getlang(2144,gu(unum,1)),c,(c>1 && c!=0) ? "chanlevs" : "chanlev");
  PQclear(res);
}

void load_cservice_cmd_delchan(void) {
  chl_add(command_module,command_name,cservice_cmd_delchan,command_oper,command_type,command_auth,command_desc);
}
