/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : ghost.c                                                     :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "channels.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "ghost"
#define command_desc   2364
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_ghost(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char hashpw[50],tpfl[30]; char *usr;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2023,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2024,gu(unum,1)));
    m_notice(unum,target,getlang(2025,gu(unum,1)));    
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  strtolower(cargs[0]);
  res=pg_query("SELECT account,passwd,flags FROM users WHERE lower(account)='%s';",cargs[0]);
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(2026,gu(unum,1)),cargs[0]);
    PQclear(res);
    return;
  }
  /* hash the password */
  resetchar(hashpw);
  getmd5(cargs[1],hashpw);
  if (strcmp(PQgetvalue(res,0,1),hashpw)) {
    m_notice(unum,target,getlang(2027,gu(unum,1)));
    PQclear(res);
    return;
  }
  resetchar(tpfl);
  strcp(tpfl,PQgetvalue(res,0,2));
  PQclear(res);
  /* now find the user */
  usr=nick2num(cargs[0]);
  if (usr==NULL) {
    m_notice(unum,target,getlang(8213,gu(unum,1)),cargs[0]);
    return;
  }
  if (!strcmp(usr,unum)) {
    m_notice(unum,target,getlang(2365,gu(unum,1)));
    return;
  }
  if (chrstr('g',tpfl)) {
    send2up("%s D %s :%s (GHost. You are being disconnected.)",getmodsnum(command_module),usr,mconfig_get("servername","modserv.default.org"));
  } else {
    send2up("%s D %s :%s (GHost by %s. You are being disconnected.)",getmodsnum(command_module),usr,mconfig_get("servername","modserv.default.org"),num2nick(unum));
  }
  m_notice(unum,target,getlang(2366,gu(unum,1)));
}

void load_cservice_cmd_ghost(void) {
  chl_add(command_module,command_name,cservice_cmd_ghost,command_oper,command_type,command_auth,command_desc);
}
