/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : key.c                                                       :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "channels.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "key"
#define command_desc   2370
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_key(char *arg, char *unum, char *target) {
  strarray(arg); cusers *a; chans *c; PGresult *res;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2371,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    m_notice(unum,target,getlang(2372,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(8202,gu(unum,1)));
    return;
  }
  c=cptr(cargs[0]);
  if (c==NULL) {
    return;
  }
  if (cargc==1) {
    /* just display the channel key */
    strtolower(c->name);
    res=pg_query("SELECT ckey FROM channels WHERE lower(channel)='%s';",c->name);
    if (pg_num_rows(res)<1) {
      PQclear(res);
      return;
    }
    if (PQgetvalue(res,0,0)==NULL) {
      m_notice(unum,target,getlang(2373,gu(unum,1)),c->name);
    } else {
      m_notice(unum,target,getlang(2374,gu(unum,1)),c->name,PQgetvalue(res,0,0));
    }
    PQclear(res);
    return;
  }
  if (strlen(cargs[1])>50) {
    m_notice(unum,target,getlang(2375,gu(unum,1)));
    return;
  }
  pg_query("UPDATE channels SET ckey='%s' WHERE lower(channel)='%s';",cargs[1],c->name);
  m_notice(unum,target,getlang(2376,gu(unum,1)),c->name,cargs[1]);
  if (!chrstr('k',c->modes)) {
    appchar(c->modes,'k');
    strsortn(c->modes);
  }
  send2up("%s M %s +k %s",getmodsnum(command_module),c->name,cargs[1]);
}

void load_cservice_cmd_key(void) {
  chl_add(command_module,command_name,cservice_cmd_key,command_oper,command_type,command_auth,command_desc);
}
