/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : kick.c                                                      :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "kick"
#define command_desc   2160
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_kick(char *arg, char *unum, char *target) {
  strarray(arg); chans *a; cusers *b; users *c; char maskcmp[512],reason[250],cmpmask[512];
  char *myc; unsigned int users_kicked=0,i=0;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2161,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    m_notice(unum,target,getlang(2162,gu(unum,1)));
    m_notice(unum,target,getlang(2163,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2164,gu(unum,1)));
    return;
  }
  a=cptr(cargs[0]);
  if (a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  resetchar(maskcmp);
  if (chrstr('@',cargs[1])) {
    // mask kick
    strncpy(maskcmp,cargs[1],strlen(cargs[1]));
    maskcmp[strlen(cargs[1])]=0x00;
  } else {
    // nick kick
    sprintf(maskcmp,"%s!*@*",cargs[1]);
  }
  resetchar(reason);
  for(i=2;i<=cargc;i++) {
    strcat(reason,cargs[i]);
    if (i!=cargc) {
      strcat(reason," ");
    }
  }
  resetchar(cmpmask);
  for(b=cuser_list;b!=NULL;b=b->next) {
    if (!strcmp(b->name,cargs[0])) {
      c=uptr(b->unum);
      if (c==NULL) continue;
      sprintf(cmpmask,"%s!%s@%s",c->nick,c->ident,c->host);
      if (strmatch(maskcmp,cmpmask)) {
        send2up("%s K %s %s :%s",target,b->name,b->unum,reason);
        delcuser(b->name,b->unum);
        users_kicked++;
      }
    }
  }
  m_notice(unum,target,getlang(2165,gu(unum,1)),users_kicked,(users_kicked==1) ? "" : "s",reason);
}

void load_cservice_cmd_kick(void) {
  chl_add(command_module,command_name,cservice_cmd_kick,command_oper,command_type,command_auth,command_desc);
}
