/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : register.c                                                  :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "register"
#define command_desc   2172
#define command_oper   0
#define command_type   1
#define command_auth   0

#define min_passlen    6

char base64str[70];

void cservice_cmd_register(char *arg, char *unum, char *target) {
  strarray(arg); unsigned int i,j=0,somesum=0; PGresult *res; char tmpcode[40],tmps[20],mailsub[512],hashpw[50],tmpnick[50];
  strcpy(base64str,"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789[]");
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2173,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2174,gu(unum,1)));
    m_notice(unum,target,getlang(2175,gu(unum,1)));
    m_notice(unum,target,getlang(2176,gu(unum,1)));
    return;
  } else if (cargc<3) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  assert(num2nick(unum));
  resetchar(tmpnick);
  strcp(tmpnick,num2nick(unum));
  strtolower(tmpnick);
  res=pg_query("SELECT account FROM users WHERE lower(account)='%s';",tmpnick);
  if (PQntuples(res)>0) {
    m_notice(unum,target,getlang(2177,gu(unum,1)),num2nick(unum));
    PQclear(res);
    return;
  }
  PQclear(res);
  if (strlen(cargs[0])<min_passlen) {
    m_notice(unum,target,getlang(2178,gu(unum,1)),min_passlen);
    return;
  } else if (strlen(cargs[0])>64) {
    m_notice(unum,target,getlang(2179,gu(unum,1)));
    return;
  }
  if (!strcasecmp(num2nick(unum),cargs[0])) {
    m_notice(unum,target,getlang(2180,gu(unum,1)));
    return;
  }
  if (strcasecmp(cargs[1],cargs[2])) {
    m_notice(unum,target,getlang(2181,gu(unum,1)));
    return;
  } else if (strlen(cargs[1])>255) {
    m_notice(unum,target,getlang(2182,gu(unum,1)));
    return;
  }
  for(i=0;i<strlen(cargs[1]);i++) {
    if (cargs[1][i]=='@') {
      j=1; break;
    }
  }
  if (!j) {
    m_notice(unum,target,getlang(2150,gu(unum,1)));
    return;
  }
  // Generate activation-code.
  srand(time(NULL));
  tmpcode[0]=0x00;
  for(i=1;i<=12;i++) {
    somesum=rand()%strlen(base64str);
    sprintf(tmps,"%c",base64str[somesum]);
    strcat(tmpcode,tmps);
    if (i==4 || i==8) strcat(tmpcode,"-");
  }
  /* hashing password */
  resetchar(hashpw);
  getmd5(cargs[0],hashpw);
  /* Adding entry into database */
  pg_query("INSERT INTO users (account,passwd,email,created,actcode) VALUES ('%s','%s','%s','%ld','%s');",num2nick(unum),hashpw,cargs[1],time(NULL),tmpcode);  
  sprintf(mailsub,"[%s]: %s",mconfig_get("network","GamerIRC"),getlang(2189,gu(unum,1)));
  mailsend(cargs[1],mailsub,getlang(2183,gu(unum,1)),num2nick(unum),mconfig_get("acturl","http://cs.gamerirc.org/activation"),tmpcode,getmodnick(command_module),num2nick(unum),tmpcode,mconfig_get("helpchan","#help"),mconfig_get("network","GamerIRC"));
  m_notice(unum,target,getlang(2184,gu(unum,1)),num2nick(unum),mconfig_get("network","GamerIRC"));
  m_notice(unum,target,"---");
  m_notice(unum,target,getlang(2185,gu(unum,1)));
  m_notice(unum,target,getlang(2186,gu(unum,1)));
  m_notice(unum,target,getlang(2187,gu(unum,1)),cargs[1]);
  m_notice(unum,target,"---");
  m_notice(unum,target,getlang(2188,gu(unum,1)),mconfig_get("network","GamerIRC"));
}

void load_cservice_cmd_register(void) {
  chl_add(command_module,command_name,cservice_cmd_register,command_oper,command_type,command_auth,command_desc);
}
