/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : suspendauth.c                                               :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "account.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "suspendauth"
#define command_desc   2207
#define command_oper   1
#define command_type   1
#define command_auth   1

int findaccount(char *name) {
  PGresult *res;
  strtolower(name);
  res=pg_query("SELECT uid FROM users WHERE lower(account)='%s';",name);
  if (pg_num_rows(res)>0) {
    PQclear(res);
    return 1;
  } else {
    PQclear(res);
    return 0;
  }
}

void cservice_cmd_suspendauth(char *arg, char *unum, char *target) {
  strarray(arg); char account[512],reason[512],mailsub[200],mailtxt[512]; int i,users_hit=0,uid;
  long tst; users *a; PGresult *res;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2208,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2209,gu(unum,1)));
    m_notice(unum,target,getlang(2210,gu(unum,1)));
    m_notice(unum,target,getlang(2211,gu(unum,1)));
    return;
  } else if (cargc<3) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  resetchar(account);
  if (cargs[0][0]=='#') {
    sprintf(account,"%s",cargs[0]+1);
    if (!findaccount(account)) {
      m_notice(unum,target,getlang(8211,gu(unum,1)),account);
      return;
    }
  } else {
    if (!nick2num(cargs[0])) {
      m_notice(unum,target,getlang(8214,gu(unum,1)),cargs[0]);
      return;
    }
    if (!isauthed(nick2num(cargs[0]))) {
      m_notice(unum,target,getlang(8215,gu(unum,1)),cargs[0]);
      return;
    }
    strcpy(account,getauth(nick2num(cargs[0])));
  }
  uid=getuserid(account);
  if (uid<0) {
    m_notice(unum,target,getlang(2212,gu(unum,1)));
    return;
  }
  res=pg_query("SELECT suspended FROM users WHERE uid=%d AND suspended=TRUE;",uid);
  if (pg_num_rows(res)>0) {
    m_notice(unum,target,getlang(2213,gu(unum,1)),account);
    PQclear(res);
    return;
  }
  resetchar(reason);
  if ((tst=duration2long(cargs[1]))<0) {
    m_notice(unum,target,getlang(2045,gu(unum,1)));
    return;
  }
  for(i=2;i<cargc;i++) {
    strcat(reason,cargs[i]);
    strcat(reason," ");
  }
  tst+=time(NULL);
  reason[strlen(reason)-1]=0x00;
  pg_query("DELETE FROM accountsuspends WHERE uid=%d;",uid);
  pg_query("INSERT INTO accountsuspends (reason,setby,setat,expirets,uid) VALUES ('%s','%s','%ld','%ld',%d);",reason,num2nick(unum),time(NULL),tst,uid);
  pg_query("UPDATE users SET suspended=TRUE WHERE uid=%d;",uid);
  PQclear(res);
  res=pg_query("SELECT email,account FROM users WHERE uid=%d;",uid);
  if (pg_num_rows(res)>0) {
    resetchar(mailsub);
    resetchar(mailtxt);
    sprintf(mailsub,"[%s]: %s",mconfig_get("network","GamerIRC"),getlang(2214,gu(unum,1)));
    mailsend(PQgetvalue(res,0,0),mailsub,mailtxt,getlang(2215,gu(unum,1)),PQgetvalue(res,0,1),reason,cctime((time_t)tst),mconfig_get("rulesurl","http://www.gamerirc.org/rules"),mconfig_get("supportmail","support@gamerirc.org"),mconfig_get("network","GamerIRC"));
  }
  for(a=user_list;a!=NULL;a=a->next) {
    if (a->auth==NULL) continue;
    if (!strcasecmp(a->auth,account)) {
      send2up("%s D %s :%s (%s)",getmodsnum(command_module),a->unum,mconfig_get("servername","modserv.default.org"),getlang(2216,gu(unum,1)));
      killuser(a->unum);
      users_hit++;
    }
  }
  PQclear(res);
  m_notice(unum,target,getlang(2217,gu(unum,1)),account,users_hit,(users_hit==1) ? "" : "s");
}

void load_cservice_cmd_suspendauth(void) {
  chl_add(command_module,command_name,cservice_cmd_suspendauth,command_oper,command_type,command_auth,command_desc);
}
