/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : topic.c                                                        :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "channels.h"

#define command_module "cservice"
#define command_name   "topic"
#define command_desc   2218
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_topic(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char tmptopic[512]; int i,j,cid;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2219,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2220,gu(unum,1)));
    m_notice(unum,target,getlang(2221,gu(unum,1)));
    return;
  } else if (cargc<2) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!hascl(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2042,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2222,gu(unum,1)));
    return;
  }
  cid=getcid(cargs[0]);
  if (!strcmp(cargs[1],"add")) {
    // adding a new topic
    resetchar(tmptopic);
    for(i=2;i<cargc;i++) {
      strcat(tmptopic,cargs[i]);
      strcat(tmptopic," ");
    }
    tmptopic[strlen(tmptopic)-1]=0x00;
    res=pg_query("SELECT topic FROM topics WHERE cid=%d AND topic='%s';",cid,tmptopic);
    if (pg_num_rows(res)>0) {
      m_notice(unum,target,getlang(2223,gu(unum,1)));
      PQclear(res);
      return;
    } else if (pg_num_rows(res)>=10) {
      m_notice(unum,target,getlang(2224,gu(unum,1)));
      PQclear(res);
      return;
    }
    pg_query("INSERT INTO topics (cid,topic,addedby,addedat) VALUES (%d,'%s','%s','%ld');",cid,tmptopic,num2nick(unum),time(NULL));
    m_notice(unum,target,getlang(2225,gu(unum,1)),tmptopic,strlen(tmptopic));
    PQclear(res);
    return;
  } else if (!strcmp(cargs[1],"list")) {
    // listing all topics
    res=pg_query("SELECT topic,addedby,addedat FROM topics WHERE cid=%d;",cid);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2226,gu(unum,1)));
      PQclear(res);
      return;
    }
    m_notice(unum,target,getlang(2227,gu(unum,1)),cargs[0]);
    m_notice(unum,target,"---");
    for(i=0;i<pg_num_rows(res);i++) {
      m_notice(unum,target,"[#%d]: %s",i,PQgetvalue(res,i,0));
      m_notice(unum,target,getlang(2228,gu(unum,1)),strlen(PQgetvalue(res,i,0)),PQgetvalue(res,i,1),cctime((time_t)atol(PQgetvalue(res,i,2))));
    }
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2229,gu(unum,1)),i,(i==1) ? "" : "s");
    PQclear(res);
    return;
  } else if (!strcmp(cargs[1],"del")) {
    if (cargc<3) {
      m_notice(unum,target,getlang(2230,gu(unum,1)),command_name,cargs[0]);
      return;
    }
    res=pg_query("SELECT topic FROM topics WHERE cid=%d;",cid);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2226,gu(unum,1)));
      PQclear(res);
      return;
    }
    for(i=0;i<pg_num_rows(res);i++) {
      if (i==atoi(cargs[2])) {
        pg_query("DELETE FROM topics WHERE topic='%s' AND cid=%d;",PQgetvalue(res,i,0),cid);
        m_notice(unum,target,getlang(2231,gu(unum,1)),i);
        PQclear(res);
        return;
      }
    }
    m_notice(unum,target,getlang(2232,gu(unum,1)),cargs[2]);
    PQclear(res);
    return;
  } else if (!strcmp(cargs[1],"set")) {
    // set a new topic
    if (cargc<3) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    if (cargs[2][0]=='#') {
      res=pg_query("SELECT topic FROM topics WHERE cid=%d;",cid);
      if (pg_num_rows(res)<1) {
        m_notice(unum,target,getlang(2232,gu(unum,1)),cargs[2]);
        PQclear(res);
        return;
      }
      resetchar(tmptopic);
      sprintf(tmptopic,"%s",cargs[2]+1);
      if (atoi(tmptopic)>(pg_num_rows(res)-1)) {
        m_notice(unum,target,"Out of range!");
        PQclear(res);
        return;
      }
      send2up("%s T %s :%s",getmodsnum(command_module),cargs[0],PQgetvalue(res,atoi(tmptopic),0));
      m_notice(unum,target,getlang(2233,gu(unum,1)),cargs[2]);
      PQclear(res);
      return;
    } else {
      resetchar(tmptopic);
      for(i=2;i<cargc;i++) {
        strcat(tmptopic,cargs[i]);
        strcat(tmptopic," ");
      }
      tmptopic[strlen(tmptopic)-1]=0x00;
      send2up("%s T %s :%s",getmodsnum(command_module),cargs[0],tmptopic);
      return;
    }
  } else {
    m_notice(unum,target,getlang(2234,gu(unum,1)),cargs[1]);
    return;
  }
}

void load_cservice_cmd_topic(void) {
  chl_add(command_module,command_name,cservice_cmd_topic,command_oper,command_type,command_auth,command_desc);
}
