/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : userflags.c, Custom account flags.                          :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "account.h"
#include "clients.h"

#define command_module "cservice"
#define command_name   "userflags"
#define command_desc   2245
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_userflags(char *arg, char *unum, char *target) {
  strarray(arg); char *a,*x; unsigned int i,d=0,b1=0,b2=0;
  struct accounts *ac;
  if (cargc==0) {
    // display flags
    a=getuflags(getauth(unum));
    if (a==NULL) {
      m_notice(unum,target,getlang(2246,gu(unum,1)));
      return;
    }
    if (!strcmp(a,"+")) {
      m_notice(unum,target,getlang(2247,gu(unum,1)));
      return;
    }
    m_notice(unum,target,getlang(2248,gu(unum,1)),(a[0]!='+') ? "+" : "",a);
    return;
  } else {
    // set flags
    x=getauth(unum);
    for(i=0;i<strlen(cargs[0]);i++) {
      if (cargs[0][i]=='+') { d=1; continue; }
      if (cargs[0][i]=='-') { d=2; continue; }
      if (!isvaliduflag(cargs[0][i])) { continue; }
      if (d==1) {
        if (hasuflag(x,cargs[0][i])) continue;
        adduflag(x,cargs[0][i]); b1++;
        continue;
      } else if (d==2) {
        if (!hasuflag(x,cargs[0][i])) continue;
        deluflag(x,cargs[0][i]); b2++;
        continue;
      }
    }
    if (!b1 && !b2) {
      m_notice(unum,target,getlang(2249,gu(unum,1)));
    } else {
      m_notice(unum,target,getlang(2250,gu(unum,1)),b1,(b1==1) ? "" : "s",b2,(b2==1) ? "" : "s");
    }
    return;
  }
}

void load_cservice_cmd_userflags(void) {
  chl_add(command_module,command_name,cservice_cmd_userflags,command_oper,command_type,command_auth,command_desc);
}
