/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : userlevel.c, userlevel management system.                   :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"

#define command_module "cservice"
#define command_name   "userlevel"
#define command_desc   2251
#define command_oper   1
#define command_type   1
#define command_auth   1

// General Userlevels
// ---   
// 0           USER
// 1           SUPPORTER
// 2           OPERATOR
// 3           DEVELOPER

// Sub-Levels 'USER'
// ---
// VIP         Special Users
// RADIO       Radio Stream Members

// Sub-Levels 'SUPPORTER'
// ---
// TRIAL       Trial Member, no special functions
// SUPPORTER   Full Support Member
// GROUPADMIN  Support team leader
// CSERVICE    Channel Service Group (CSG:Support)

// Sub-Levels 'OPERATOR'
// ---
// OPERATOR    Normal operator
// SERVERADMIN Server administrator
// CSERVICE    Channel Service Group (CSG:oSupport)

// Sub-Levels 'DEVELOPER'
// ---
// WEBDEV      Web Developer, special access for web
// IRCDEV      IRC Developer (modserv), special access for services

void cservice_cmd_userlevel(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res,*res2; char acc[40]; unsigned int type,i;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2252,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2253,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!strcmp(cargs[0],"set")) {
    // set new level to a user
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(2254,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(2255,gu(unum,1)));
      m_notice(unum,target,getlang(2256,gu(unum,1)));
      return;
    } else if (cargc<3) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    if (cargs[1][0]=='#') {
      sprintf(acc,"%s",cargs[1]+1);
      strtolower(acc);
      res=pg_query("SELECT account,created,lastauth FROM users WHERE lower(account)='%s';",acc);
      if (pg_num_rows(res)<1) {
        m_notice(unum,target,getlang(8211,gu(unum,1)),acc);
        PQclear(res);
        return;
      }
      strcpy(acc,PQgetvalue(res,0,0));
      PQclear(res);
    } else {
      if ((char*)getauth((char*)nick2num(cargs[1]))==NULL) {
        m_notice(unum,target,getlang(8215,gu(unum,1)),cargs[1]);
        return;
      }
      strcpy(acc,(char*)getauth((char*)nick2num(cargs[1])));
    }
    res=pg_query("SELECT vdesc FROM userlevels WHERE vdesc~*'%s';",cargs[2]);
    if (!res || (pg_num_rows(res)<1)) {
      m_notice(unum,target,getlang(2257,gu(unum,1)),cargs[2]);
      PQclear(res);
      return;
    }
    strtolower(acc);
    res2=pg_query("SELECT ulevel FROM users WHERE lower(account)='%s';",acc);
    pg_query("UPDATE users SET ulevel='%s' WHERE lower(account)='%s';",PQgetvalue(res,0,0),acc);
    m_notice(unum,target,getlang(2258,gu(unum,1)),acc,PQgetvalue(res2,0,0),PQgetvalue(res,0,0));
    PQclear(res);
    PQclear(res2);
    return;
  } else if (!strcmp(cargs[0],"add")) {
    // add new level
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(2259,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(2260,gu(unum,1)));
      m_notice(unum,target,getlang(2261,gu(unum,1)));
      return;
    } else if (cargc<3) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    if (strlen(cargs[1])>40) {
      m_notice(unum,target,getlang(2262,gu(unum,1)));
      return;
    }
    type=atoi(cargs[2]);
    if ((type<0) || (type>3)) {
      m_notice(unum,target,getlang(2263,gu(unum,1)));
      return;
    }
    res=pg_query("SELECT vid FROM userlevels WHERE vdesc~*'%s';",cargs[1]);
    if (pg_num_rows(res)>0) {
      m_notice(unum,target,getlang(2264,gu(unum,1)),cargs[1],PQgetvalue(res,0,0));
      PQclear(res);
      return;
    }
    pg_query("INSERT INTO userlevels (vtype,vdesc,vid) VALUES (%d,'%s',nextval('inc_ulv'));",type,cargs[1]);
    m_notice(unum,target,getlang(2265,gu(unum,1)),cargs[1]);
    PQclear(res);
    return;
  } else if (!strcmp(cargs[0],"list")) {
    // lists available levels
    type=0;
    res=pg_query("SELECT vdesc,vid FROM userlevels WHERE vtype=0;");
    m_notice(unum,target,getlang(2266,gu(unum,1)),pg_num_rows(res));
    for(i=0;i<pg_num_rows(res);i++,type++) {
      m_notice(unum,target,"-> %s (#%s)",PQgetvalue(res,i,0),PQgetvalue(res,i,1));
    }
    PQclear(res);
    res=pg_query("SELECT vdesc,vid FROM userlevels WHERE vtype=1;");
    m_notice(unum,target,getlang(2267,gu(unum,1)),pg_num_rows(res));
    for(i=0;i<pg_num_rows(res);i++,type++) {
      m_notice(unum,target,"-> %s (#%s)",PQgetvalue(res,i,0),PQgetvalue(res,i,1));
    }
    PQclear(res);
    res=pg_query("SELECT vdesc,vid FROM userlevels WHERE vtype=2;");
    m_notice(unum,target,getlang(2268,gu(unum,1)),pg_num_rows(res));
    for(i=0;i<pg_num_rows(res);i++,type++) {
      m_notice(unum,target,"-> %s (#%s)",PQgetvalue(res,i,0),PQgetvalue(res,i,1));
    }
    PQclear(res);
    res=pg_query("SELECT vdesc,vid FROM userlevels WHERE vtype=3;");
    m_notice(unum,target,getlang(2269,gu(unum,1)),pg_num_rows(res));
    for(i=0;i<pg_num_rows(res);i++,type++) {
      m_notice(unum,target,"-> %s (#%s)",PQgetvalue(res,i,0),PQgetvalue(res,i,1));
    }
    PQclear(res);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2270,gu(unum,1)),type,(type>1&&type!=0) ? "s" : "");
    return;
  } else if (!strcmp(cargs[0],"del")) {
    // removes a level
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(2271,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(2272,gu(unum,1)));
      m_notice(unum,target,getlang(2273,gu(unum,1)));
      return;
    } else if (cargc<2) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    res=pg_query("SELECT vid FROM userlevels WHERE vdesc~*'%s';",cargs[1]);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2257,gu(unum,1)),cargs[1]);
      PQclear(res);
      return;
    }
    PQclear(res);
    // we need to reset all user accounts to level 'user' now
    res=pg_query("SELECT account FROM users WHERE level='%s';",cargs[1]);
    type=pg_num_rows(res);
    pg_query("UPDATE users SET level='user' WHERE level='%s';",cargs[1]);
    pg_query("DELETE FROM userlevels WHERE vdesc='%s';",cargs[1]);
    PQclear(res);
    m_notice(unum,target,getlang(2274,gu(unum,1)),cargs[1],type,(type>1) ? "s" : "");
    return;
  } else {
    // unknown option
    m_notice(unum,target,getlang(2275,gu(unum,1)),cargs[0]);
    return;
  }

}

void load_cservice_cmd_userlevel(void) {
  chl_add(command_module,command_name,cservice_cmd_userlevel,command_oper,command_type,command_auth,command_desc);
}
