/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : vhost.c, vhost management.                                  :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

/* WARNING:
   This command *requires* the kotaro ircd running.
   Otherwise, you can't set any user-hosts. */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "dynhdl.h"

#define command_module "cservice"
#define command_name   "vhost"
#define command_desc   2323
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_vhost(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res,*res2; char acc[40]; unsigned int type,i,uid;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2324,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2325,gu(unum,1)),getmodnick(command_module),command_name);
    m_notice(unum,target,getlang(2326,gu(unum,1)));    
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!strcmp(cargs[0],"apply")) {
    // sets a vhost to active user
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(2327,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(2328,gu(unum,1)));
      return;
    } else if (cargc<2) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    uid=getuserid(getauth(unum));
    if (uid<=0) return;
    res=pg_query("SELECT vhost FROM vhosts WHERE uid=%ld AND vhost='%s';",uid,cargs[1]);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2329,gu(unum,1)),cargs[1]);
      PQclear(res);
      return;
    }
    send2up("%s SH %s :%s",getmodsnum(command_module),num2nick(unum),PQgetvalue(res,0,0));
    m_notice(unum,target,getlang(2330,gu(unum,1)),PQgetvalue(res,0,0));
    PQclear(res);
    pg_query("UPDATE vhosts SET usec=usec+1 WHERE uid=%ld AND vhost='%s';",uid,cargs[1]);    
    return;
  } else if (!strcmp(cargs[0],"list")) {
    // lists users vhosts
    uid=getuserid(getauth(unum));
    if (uid<=0) return;
    res=pg_query("SELECT vhost,usec FROM vhosts WHERE uid=%ld;",uid,cargs[0]);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2331,gu(unum,1)));
      PQclear(res);
      return;
    }
    m_notice(unum,target,getlang(2334,gu(unum,1)),pg_num_rows(res));
    m_notice(unum,target,"---");
    for(i=0;i<pg_num_rows(res);i++) {
      if ((i+1)>=pg_num_rows(res)) {
        m_notice(unum,target,getlang(2332,gu(unum,1)),PQgetvalue(res,i,0),(int)PQgetvalue(res,i,1));
      } else {
        m_notice(unum,target,getlang(2333,gu(unum,1)),PQgetvalue(res,i,0),(int)PQgetvalue(res,i,1));
      }
    }   
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(8209,gu(unum,1)));
    PQclear(res);
    return;
  } else if (!strcmp(cargs[0],"del")) {
    // removes a vHost
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(2335,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(2336,gu(unum,1)));
      return;
    } else if (cargc<2) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    uid=getuserid(getauth(unum));
    if (uid<=0) return;    
    res=pg_query("SELECT vhost FROM vhosts WHERE uid=%ld AND vhost='%s';",uid,cargs[1]);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2329,gu(unum,1)),cargs[1]);
      PQclear(res);
      return;
    }
    PQclear(res);
    pg_query("DELETE FROM vhosts WHERE uid=%ld AND vhost='%s';",uid,cargs[1]);
    m_notice(unum,target,getlang(2337,gu(unum,1)),cargs[1]);
    return;
  } else if (!strcmp(cargs[0],"default")) {
    // sets a default account vhost
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(2338,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(2339,gu(unum,1)));
      return;
    } else if (cargc<2) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    uid=getuserid(getauth(unum));
    if (uid<=0) return;
    res=pg_query("SELECT vhost FROM vhosts WHERE uid=%ld AND vhost='%s';",uid,cargs[1]);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(2329,gu(unum,1)),cargs[1]);
      PQclear(res);
      return;
    }
    PQclear(res);
    /* first set all vhosts default=false, then the correct vhost default=true */
    pg_query("UPDATE vhosts SET default=FALSE WHERE uid=%ld;",uid);
    pg_query("UPDATE vhosts SET default=TRUE WHERE uid=%ld AND vhost='%s';",uid,cargs[1]);
    m_notice(unum,target,getlang(2340,gu(unum,1)),cargs[1]);
    return;    
  } else {
    // unknown option
    m_notice(unum,target,getlang(2275,gu(unum,1)),cargs[0]);
    return;
  }
}

void load_cservice_cmd_vhost(void) {
  chl_add(command_module,command_name,cservice_cmd_vhost,command_oper,command_type,command_auth,command_desc);
}
