/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : welcome.c - Manages the on-join greeting message.           :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"

#define command_module "cservice"
#define command_name   "welcome"
#define command_desc   2281
#define command_oper   0
#define command_type   1
#define command_auth   1

unsigned int findchannel(char *chan) {
  PGresult *res;
  strtolower(chan);
  res=pg_query("SELECT * FROM channels WHERE lower(channel)='%s';",chan);
  if (!res) {
    PQclear(res);
    return 0;
  }
  if (PQntuples(res)<1) {
    PQclear(res);
    return 0;
  } else {
    PQclear(res);
    return 1;
  }
}

void cservice_cmd_welcome(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; char *h; char tmp[512]; unsigned int i,j,a=0,b=0; int cid;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2282,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2059,gu(unum,1)));
    m_notice(unum,target,getlang(2283,gu(unum,1)));
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2284,gu(unum,1)));
    m_notice(unum,target,getlang(2285,gu(unum,1)));
    m_notice(unum,target,getlang(2286,gu(unum,1)));
    m_notice(unum,target,getlang(2287,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!findchannel(cargs[0])) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  if (!cl_master(cargs[0],unum) && !cl_owner(cargs[0],unum) && !isoper(unum)) {
    m_notice(unum,target,getlang(2288,gu(unum,1)));
    return;
  }
  cid=getcid(cargs[0]);
  if (cargc==1) {
    // displaying message
    res=pg_query("SELECT message FROM greetings WHERE cid=%d;",cid);
    if (!res || (pg_num_rows(res)<1)) {
      m_notice(unum,target,getlang(2289,gu(unum,1)));
      PQclear(res);
      return;
    }
    h=PQgetvalue(res,0,0);
    resetchar(tmp);
    getchanbyid(cid,tmp);
    m_notice(unum,target,getlang(2290,gu(unum,1)),tmp,strlen(h)-1);
    m_notice(unum,target,"%s",h);
    PQclear(res);
    return;
  } else {
    // setting message
    if (!strcmp(cargs[1],"remove")) {
      pg_query("DELETE FROM greetings WHERE cid=%d;",cid);
      m_notice(unum,target,getlang(2291,gu(unum,1)));
      return;
    }
    strcpy(tmp,"");
    for(i=1;i<=cargc;i++) {
      strcat(tmp,cargs[i]);
      if (i!=cargc) {
        strcat(tmp," ");
      }
    }
    if (strlen(tmp)>300) {
      m_notice(unum,target,getlang(2292,gu(unum,1)),strlen(tmp));
      m_notice(unum,target,getlang(2293,gu(unum,1)),(299-strlen(tmp)));
      return;
    }
    pg_query("DELETE FROM greetings WHERE cid=%d;",cid);
    pg_query("INSERT INTO greetings (message,setby,setat,cid) VALUES ('%s','%s','%ld',%d);",tmp,num2nick(unum),time(NULL),cid);
    m_notice(unum,target,getlang(2294,gu(unum,1)));
    return;
  }
}

void load_cservice_cmd_welcome(void) {
  chl_add(command_module,command_name,cservice_cmd_welcome,command_oper,command_type,command_auth,command_desc);
}
