/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : whois.c                                                     :
   : (c) 2004 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"
#include "strfunc.h"

#define command_module "cservice"
#define command_name   "whois"
#define command_desc   2300
#define command_oper   0
#define command_type   1
#define command_auth   1

void cservice_cmd_whois(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res,*res2; char acc[40],sc[300]; time_t cr,la,ex; cusers *a; char *f,*h,*x,*x2;
  unsigned int i,ouc=0; long muh; char onlineusers[512],tmpacc[50]; users *ux; int xs;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(2301,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2302,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (cargs[0][0]=='#') {
    sprintf(acc,"%s",cargs[0]+1);
    strtolower(acc);
    res=pg_query("SELECT account,created,lastauth,authcount,authfails,suspended,email,ulevel FROM users WHERE lower(account)='%s';",acc); 
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(8211,gu(unum,1)),acc);
      PQclear(res);
      return;
    }
    res2=pg_query("SELECT vtype FROM userlevels WHERE vdesc='%';",PQgetvalue(res,0,7));       
    m_notice(unum,target,getlang(2303,gu(unum,1)),PQgetvalue(res,0,0));
  } else {
    if (nick2num(cargs[0]) == NULL) {
      m_notice(unum,target,getlang(8213,gu(unum,1)),cargs[0]);
      return;
    }
    if (getauth(nick2num(cargs[0]))==NULL) {
      m_notice(unum,target,getlang(8215,gu(unum,1)),cargs[0]);
      return;
    }
    resetchar(tmpacc);
    strcp(tmpacc,getauth(nick2num(cargs[0])));
    strtolower(tmpacc);
    res=pg_query("SELECT account,created,lastauth,authcount,authfails,suspended,email,ulevel,lang FROM users WHERE lower(account)='%s';",tmpacc);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(8215,gu(unum,1)),cargs[0]);
      PQclear(res);
      return;    
    }
    m_notice(unum,target,getlang(2304,gu(unum,1)),num2nick(nick2num(cargs[0])),PQgetvalue(res,0,0));
  }
  cr=atol(PQgetvalue(res,0,1));
  la=atol(PQgetvalue(res,0,2));
  m_notice(unum,target,getlang(2305,gu(unum,1)));
  m_notice(unum,target,getlang(2306,gu(unum,1)),ctime(&cr));
  m_notice(unum,target,getlang(2307,gu(unum,1)),(la==0) ? getlang(2322,gu(unum,1)) : ctime(&la));
  m_notice(unum,target,getlang(2308,gu(unum,1)),PQgetvalue(res,0,7));
  m_notice(unum,target,getlang(2347,gu(unum,1)),PQgetvalue(res,0,8));
  if (isoper(unum)) {
    f=PQgetvalue(res,0,5);
    m_notice(unum,target,getlang(2309,gu(unum,1)),PQgetvalue(res,0,3));
    m_notice(unum,target,getlang(2310,gu(unum,1)),PQgetvalue(res,0,4));
    m_notice(unum,target,getlang(2311,gu(unum,1)),(f[0]=='f') ? getlang(8205,gu(unum,1)) : getlang(8204,gu(unum,1)));
    if (f[0]!='f') {
      resetchar(tmpacc);
      strcp(tmpacc,PQgetvalue(res,0,0));
      strtolower(tmpacc);
      res2=pg_query("SELECT reason,suspendtime,suspendby,expire FROM suspends WHERE lower(account)='%s';",tmpacc);
      if (res2 && (pg_num_rows(res2)>0)) {
        ex=atol(PQgetvalue(res2,0,3));
        muh=(time(NULL)-ex);
        h=duration(muh);
        m_notice(unum,target,getlang(2312,gu(unum,1)),PQgetvalue(res2,0,0));
        m_notice(unum,target,getlang(2313,gu(unum,1)),PQgetvalue(res2,0,1));
        m_notice(unum,target,getlang(2314,gu(unum,1)),PQgetvalue(res2,0,2));
        m_notice(unum,target,getlang(2315,gu(unum,1)),cctime(ex),h);
        free(h);
      }
      PQclear(res2);
    }
  }
  if (hasuflag(PQgetvalue(res,0,0),'e')) {
    if (isoper(unum)) {
      m_notice(unum,target,getlang(2316,gu(unum,1)),PQgetvalue(res,0,6));
    }
  } else {
    m_notice(unum,target,getlang(2316,gu(unum,1)),PQgetvalue(res,0,6));
  }
  resetchar(onlineusers);
  for(ux=user_list;ux!=NULL;ux=ux->next) {
    assert(ux->auth);
    if (!strcmp(ux->auth,PQgetvalue(res,0,0))) {
      strcat(onlineusers,ux->nick);
      strcat(onlineusers," ");
      ouc++;
    }
  }
  if (ouc>0) {
    m_notice(unum,target,getlang(2317,gu(unum,1)),ouc,onlineusers);
  } else {
    m_notice(unum,target,getlang(2318,gu(unum,1)));
  }
  if (!hasuflag(PQgetvalue(res,0,0),'h') || isoper(unum)) {
    resetchar(tmpacc);
    strcp(tmpacc,PQgetvalue(res,0,0));
    strtolower(tmpacc);
    res2=pg_query("SELECT channel,flags FROM chanlevs WHERE lower(account)='%s';",tmpacc);
    if (res2 && (pg_num_rows(res2)>0)) {
      m_notice(unum,target,getlang(2319,gu(unum,1)));
      for(i=0;i<pg_num_rows(res2);i++) {
        x=PQgetvalue(res2,i,1);
        m_notice(unum,target,"\02%s (\02%s%s\02)\02",PQgetvalue(res2,i,0),(x[0]!='+') ? "+" : "",x);
      }
    }
    PQclear(res2);
  }
  PQclear(res);
}

void load_cservice_cmd_whois(void) {
  chl_add(command_module,command_name,cservice_cmd_whois,command_oper,command_type,command_auth,command_desc);
}
