/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : operserv.c, operator services                               :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "schedule.h"

#define module_name  "operserv"
#define module_desc  "Operator services"
#define module_nick  "O2"
#define module_ident "operserv"
#define module_host  "operserv.gamerirc.org"
#define module_modes "+dkr"
#define module_auth  1
#define module_real  "ModServ oService"

void clear_expired_glines(void) {
  pg_query("DELETE FROM glines WHERE expirets<%ld",time(NULL));
}

void operserv_init(void) {
  PGresult *res; unsigned int i,j;
  client_create(module_name,module_nick,module_ident,module_host,module_modes,module_auth,module_real);
  res=pg_query("SELECT \"channel\" FROM ochannels");
  if (!res) {
    slog("** PgSQL: Select * from ochannels failed!");
    PQclear(res);
    return;
  }
  for(i=0;i<pg_num_rows(res);i++) {
    if (PQgetvalue(res,i,0)==NULL) continue;
    client_join(module_nick,PQgetvalue(res,i,0));
  }
  PQclear(res);
  slog("** operserv: Joined %d %s",i,(i>1) ? "channels" : "channel");
  addtask(module_name,"Clears expired G-lines",60,clear_expired_glines,TASK_PERM);
}

void operserv_close(void) {
  client_close(module_nick,"operservice closed.");
}
