/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : fixchan.c                                                   :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"

#define command_module "operserv"
#define command_name   "fixchan"
#define command_desc   3012
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_fixchan(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; chans *a; cusers *c; users *b; int users_opped=0; char ulist[520],cmo[20];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3001,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(2133,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  a=cptr(cargs[0]);
  if (a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  /* check if we have any regular ops, if not, cancel the fixchan */
  res=pg_query("SELECT * FROM cfdata WHERE chan='%s'",a->name);
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(3007,gu(unum,1)),a->name);
    PQclear(res);
    return;
  }
  PQclear(res);
  /* clear all ops and op the scores out of the database */
  send2up("%s CM %s :o",mconfig_get("numeric","JP"),a->name);
  for(c=cuser_list;c!=NULL;c=c->next) {
    if (!strcmp(c->name,a->name) && IsOpped(c->flags)) {
      ClrOpped(c->flags);
    }
  }
  resetchar(ulist);
  resetchar(cmo);
  for(c=cuser_list;c!=NULL;c=c->next) {
    if (!strcmp(c->name,a->name)) {
      b=uptr(c->unum);
      if (b==NULL) continue;
      res=pg_query("SELECT * FROM cfdata WHERE chan='%s' AND uhash='%s' AND score>=4",a->name,b->hash);
      if (pg_num_rows(res)>0) {
        /* suitable op, we should op him */
        strcat(ulist,c->unum);
        strcat(ulist," ");
        strcat(cmo,"o");
        if (strlen(cmo)>=stddef_maxmpln) {
          ulist[strlen(ulist)-1]=0x00;
          send2up("%s M +%s %s",mconfig_get("numeric","JP"),cmo,ulist);
          resetchar(ulist);
          resetchar(cmo);
        }
        SetOpped(c->flags);
        users_opped++;
      }
      PQclear(res);
    }
  }
  if (strlen(cmo)>0) {
    ulist[strlen(ulist)-1]=0x00;
    send2up("%s M %s +%s %s",mconfig_get("numeric","JP"),a->name,cmo,ulist);
    resetchar(ulist);
    resetchar(cmo);
  }
  m_notice(unum,target,getlang(3013,gu(unum,1)),a->name,users_opped,(users_opped==1) ? "" : "s");
}

void load_operserv_cmd_fixchan(void) {
  chl_add(command_module,command_name,operserv_cmd_fixchan,command_oper,command_type,command_auth,command_desc);
}
