/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : gline.c                                                     :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"
#include "strfunc.h"

#define command_module "operserv"
#define command_name   "gline"
#define command_desc   3028
#define command_oper   1
#define command_type   1
#define command_auth   1

int delusersbymask(char *mask) {
  users *a; char tmpmask[250]; int affected=0;
  resetchar(tmpmask);
  for(a=user_list;a!=NULL;a=a->next) {
    sprintf(tmpmask,"%s!%s@%s",a->nick,a->ident,a->host);
    if (strmatch(tmpmask,mask)) {
      killuser(a->unum);
      a=user_list; continue;
      affected++;
    }
  }
  return affected;
}

void operserv_cmd_gline(char *arg, char *unum, char *target) {
  strarray(arg); char *usr; char reason[250],mask[300]; int i,hit_users=0; long dur; PGresult *res,*rex;
  time_t a1,a2;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3029,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3030,gu(unum,1)));
    m_notice(unum,target,getlang(3031,gu(unum,1)));
    m_notice(unum,target,getlang(3032,gu(unum,1)));
    m_notice(unum,target,getlang(3033,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (cargs[0][0]=='+') {
    /* adding gline */
    resetchar(mask);
    sprintf(mask,"%s",cargs[0]+1);
    mask[strlen(mask)]=0x00;
    res=pg_query("SELECT mask,addedby,addedat FROM glines WHERE mask='%s';",mask);
    if (pg_num_rows(res)>0) {
      m_notice(unum,target,getlang(3034,gu(unum,1)),PQgetvalue(res,0,0),PQgetvalue(res,0,1),cctime((time_t)atol(PQgetvalue(res,0,2))));
      PQclear(res);
      return;
    }
    PQclear(res);
    if (cargc<2) {
      m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
      return;
    }
    dur=duration2long(cargs[1]);
    if (dur==-1) {
      m_notice(unum,target,getlang(3035,gu(unum,1)));
      return;
    }
    resetchar(reason);
    strcp(reason,"no reason given");
    if (cargc>=3) {
      resetchar(reason);
      for(i=2;i<cargc;i++) {
        strcat(reason,cargs[i]);
        if ((i+1)<cargc) {
          strcat(reason," ");
        }
      }
      reason[strlen(reason)]=0x00;
    }
    pg_query("INSERT INTO glines (mask,addedby,addedat,expirets,reason) VALUES ('%s','%s','%ld','%ld','%s');",mask,num2nick(unum),time(NULL),time(NULL)+dur,reason);
    send2up("%s GL * +%s %ld :%s",mconfig_get("numeric","JP"),mask,dur,reason);
    hit_users=delusersbymask(mask);
    m_notice(unum,target,getlang(3036,gu(unum,1)),mask,cctime((time_t)time(NULL)+dur),hit_users);
    return;
  } else if (cargs[0][0]=='-') {
    /* removing gline */
    resetchar(mask);
    sprintf(mask,"%s",cargs[0]+1);
    mask[strlen(mask)]=0x00;
    res=pg_query("SELECT mask,addedby,addedat FROM glines WHERE mask='%s';",mask);
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(3037,gu(unum,1)),mask);
      PQclear(res);
      return;
    }
    PQclear(res);
    send2up("%s GL * -%s",mconfig_get("numeric","JP"),mask);
    pg_query("DELETE FROM glines WHERE mask='%s'",mask);
    m_notice(unum,target,getlang(3038,gu(unum,1)),mask);
    return;
  } else if (cargs[0][0]=='?') {
    /* searching gline */
    resetchar(mask);
    sprintf(mask,"%s",cargs[0]+1);
    mask[strlen(mask)]=0x00;
    res=pg_query("SELECT mask,addedby,addedat,expirets FROM glines WHERE mask LIKE '%s%s%s';","%",mask,"%");
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(3037,gu(unum,1)),mask);
      PQclear(res);
      return;
    }
    m_notice(unum,target,getlang(3039,gu(unum,1)),pg_num_rows(res));
    m_notice(unum,target,"---");
    for(i=0;i<pg_num_rows(res);i++) {
      printf("COL %d: (%s)/(%s)/(%s)\n",i,PQgetvalue(res,i,0),PQgetvalue(res,i,2),PQgetvalue(res,i,3));
      a1=atol(PQgetvalue(res,i,2));
      a2=atol(PQgetvalue(res,i,3));
      m_notice(unum,target,getlang(3040,gu(unum,1)),PQgetvalue(res,i,0),cctime(a2),PQgetvalue(res,i,1),cctime(a1));
    }
    PQclear(res);
    return;
  } else if (cargs[0][0]=='!') {
    /* displaying information */
    resetchar(mask);
    sprintf(mask,"%s",cargs[0]+1);
    mask[strlen(mask)]=0x00;
    rex=pg_query("SELECT mask,addedby,addedat,expirets,reason FROM glines WHERE mask='%s';",mask);
    if (pg_num_rows(rex)<1) {
      m_notice(unum,target,getlang(3037,gu(unum,1)),mask);
      PQclear(rex);
      return;
    }
    a1=atol(PQgetvalue(rex,0,2));    
    a2=atol(PQgetvalue(rex,0,3));
    resetchar(mask);
    durationcp((a2-a1),mask);  
    m_notice(unum,target,getlang(3047,gu(unum,1)),PQgetvalue(rex,0,0),PQgetvalue(rex,0,1),cctime(a1));
    m_notice(unum,target,getlang(3048,gu(unum,1)),cctime(a2),mask);
    m_notice(unum,target,getlang(3049,gu(unum,1)),PQgetvalue(rex,0,4));
    PQclear(rex);   
    return;
  } else {
    /* unknown option */
    m_notice(unum,target,getlang(3041,gu(unum,1)));
    return;
  }
}

void load_operserv_cmd_gline(void) {
  chl_add(command_module,command_name,operserv_cmd_gline,command_oper,command_type,command_auth,command_desc);
}
