/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : regoplist.c                                                 :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"
#include "configx.h"

#define command_module "operserv"
#define command_name   "regoplist"
#define command_desc   3006
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_regoplist(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; chans *a; users *c; int opcount=0; char *th,*tmpe;; char ta[256];
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3001,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3002,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  a=cptr(cargs[0]);
  if (a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  strtolower(a->name);
  res=pg_query("SELECT uhash,score,lastopped FROM cfdata WHERE lower(chan)='%s' ORDER BY score DESC;",a->name);
  if (pg_num_rows(res)<1) {
    m_notice(unum,target,getlang(3007,gu(unum,1)),a->name);
    if (getusercount(a->name)<atoi(mconfig_get("cf_mincount","4"))) {
      m_notice(unum,target,getlang(3008,gu(unum,1)));
    }
    PQclear(res);
    return;
  } else {
    m_notice(unum,target,getlang(3009,gu(unum,1)),a->name,pg_num_rows(res));
    m_notice(unum,target,"---");
    for(opcount=0;opcount<pg_num_rows(res);opcount++) {
      th=NULL;
      tmpe=PQgetvalue(res,opcount,0);
      for(c=user_list;c!=NULL;c=c->next) {
        assert(c->hash);
        assert(tmpe);
        if (!strcmp(c->hash,tmpe)) {
          th=c->nick;
          if (c->auth[0]!='\0') {
            sprintf(ta,"%s@%s/account %s",c->ident,c->host,c->auth);
          } else {
            sprintf(ta,"%s@%s",c->ident,c->host);
          }
        }
      }
      if (th==NULL) {
        m_notice(unum,target,getlang(3010,gu(unum,1)),opcount+1,PQgetvalue(res,opcount,0));
      } else {
        m_notice(unum,target,"%d. \02%s\02 (%s)",opcount+1,th,ta);
      }
      m_notice(unum,target,getlang(3011,gu(unum,1)),atoi(PQgetvalue(res,opcount,1)),cctime((time_t)atol(PQgetvalue(res,opcount,2))));
    }
  }
  PQclear(res);
}

void load_operserv_cmd_regoplist(void) {
  chl_add(command_module,command_name,operserv_cmd_regoplist,command_oper,command_type,command_auth,command_desc);
}
