/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : requestop.c                                                 :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"
#include "configx.h"

#define command_module "operserv"
#define command_name   "requestop"
#define command_desc   3092
#define command_oper   0
#define command_type   1
#define command_auth   1

/* regoplog service -- status codes
     0 = fail;    there are opped users on the channel
     1 = fail;    optional user not online
     2 = fail;    user is not on the channel
     2 = success; user has been opped manually
     4 = success; users have been opped using chanfix
 */
     

void operserv_cmd_requestop(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; chans *a; cusers *c; char *usertobeopped; int opcount=0,opped=0;
  char ulist[512],cmo[10]; users *d;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3092,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3002,gu(unum,1)));
    m_notice(unum,target,getlang(3093,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  a=cptr(cargs[0]);
  if (a==NULL) {
    m_notice(unum,target,getlang(8212,gu(unum,1)),cargs[0]);
    return;
  }
  for(c=cuser_list;c!=NULL;c=c->next) {
    if (!strcmp(c->name,a->name) && IsOpped(c->flags)) {
      m_notice(unum,target,getlang(3094,gu(unum,1)),a->name);
      pg_query("INSERT INTO rops (channel,nick,ts,result,opped) VALUES ('%s','%s','%ld',0,0);",a->name,num2nick(unum),time(NULL));
      return;
    }
  }
  res=pg_query("SELECT uhash FROM cfdata WHERE chan='%s' AND score>=4;",a->name);
  if (pg_num_rows(res)<1) {
    /* no regular ops available, manual opping */
    if (cargc>=2) {
      usertobeopped=nick2num(cargs[1]);
      if (usertobeopped==NULL) {
        m_notice(unum,target,getlang(8214,gu(unum,1)),cargs[1]);
        pg_query("INSERT INTO rops (channel,nick,ts,result,opped) VALUES ('%s','%s','%ld',1,0);",a->name,num2nick(unum),time(NULL));
        PQclear(res);
        return;
      }
    } else {
      usertobeopped=unum;
    }
    c=cuptr(cargs[0],usertobeopped);
    if (c==NULL) {
      m_notice(unum,target,getlang(3104,gu(unum,1)),(cargc>=2) ? cargs[1] : num2nick(unum),a->name);
        pg_query("INSERT INTO rops (channel,nick,ts,result,opped) VALUES ('%s','%s','%ld',2,0);",a->name,num2nick(unum),time(NULL));      
      PQclear(res);
      return;
    }
    send2up("%s M %s +o %s",mconfig_get("numeric","JP"),a->name,usertobeopped);
    SetOpped(c->flags);
    pg_query("INSERT INTO rops (channel,nick,ts,result,opped) VALUES ('%s','%s','%ld',3,1);",a->name,num2nick(unum),time(NULL));
    PQclear(res);
    return;
  } else {
    resetchar(ulist);
    resetchar(cmo);
    for(opcount=0;opcount<pg_num_rows(res);opcount++) {
      for(d=user_list;d!=NULL;d=d->next) {
        if (!strcmp(d->hash,PQgetvalue(res,opcount,0))) {
          strcat(ulist,d->unum);
          strcat(ulist," ");
          strcat(cmo,"o");
          c=cuptr(a->name,d->unum);
          if (c!=NULL) {
            SetOpped(c->flags);
          }
          opped++;
          if (strlen(cmo)>=6) {
            ulist[strlen(ulist)-1]=0x00;
            send2up("%s M %s +%s %s",mconfig_get("numeric","JP"),a->name,cmo,ulist);
            resetchar(ulist);
            resetchar(cmo);
          }
        }
      }
    }
    if (strlen(cmo)>0) {
      ulist[strlen(ulist)-1]=0x00;
      send2up("%s M %s +%s %s",mconfig_get("numeric","JP"),a->name,cmo,ulist);
    }
    m_notice(unum,target,getlang(3105,gu(unum,1)),opped,a->name);
    pg_query("INSERT INTO rops (channel,nick,ts,result,opped) VALUES ('%s','%s','%ld',4,%d);",a->name,num2nick(unum),time(NULL),opped);
  }
  PQclear(res);
}

void load_operserv_cmd_requestop(void) {
  chl_add(command_module,command_name,operserv_cmd_requestop,command_oper,command_type,command_auth,command_desc);
}
