/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : trust.c                                                     :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"
#include "strfunc.h"
#include "trusts.h"

#define command_module "operserv"
#define command_name   "trust"
#define command_desc   3085
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_trust(char *arg, char *unum, char *target) {
  strarray(arg); PGresult *res; trustgroup *tg,*tg2; trusthost *th,*th2=NULL;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3086,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3087,gu(unum,1)),getmodnick(command_module),command_name);
    m_notice(unum,target,getlang(3053,gu(unum,1)));
    m_notice(unum,target,getlang(3088,gu(unum,1)));
    return;
  } else if (cargc<3) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (cargs[1][0]=='#') {
    tg=gettgbyid(atoi(cargs[1]+1));
  } else {
    tg=gettgbyname(cargs[1]);
  }
  if (tg==NULL) {
    m_notice(unum,target,getlang(3065,gu(unum,1)),cargs[1]);
    return;
  }
  if (!strcasecmp(cargs[0],"add")) {
    /* adding a trust */
    res=pg_query("SELECT trustgroup FROM trusthosts WHERE address='%s';",cargs[2]);
    if (pg_num_rows(res)>0) {
      tg2=gettgbyid(atoi(PQgetvalue(res,0,0)));
      if (tg2==NULL) {
        pg_query("DELETE FROM trusthosts WHERE address='%s';",cargs[2]);
      } else {
        m_notice(unum,target,getlang(3089,gu(unum,1)),cargs[2],tg2->name,tg2->id);
        PQclear(res);
        return;
      }
    }
    PQclear(res);
    addtrust(cargs[2],tg->id);
    m_notice(unum,target,getlang(3090,gu(unum,1)),cargs[2],tg->name,tg->id);
    return;
  } else if (!strcasecmp(cargs[0],"del")) {
    /* remove a trust */
    if (cargs[1][0]=='#') {
      tg=gettgbyid(atoi(cargs[1]+1));
    } else {
      tg=gettgbyname(cargs[1]);
    }
    if (tg==NULL) {
      m_notice(unum,target,getlang(3065,gu(unum,1)),cargs[1]);
      return;
    }
    deltrust(cargs[2],tg->id);
    m_notice(unum,target,getlang(3091,gu(unum,1)),cargs[2]);
    return;
  }
}

void load_operserv_cmd_trust(void) {
  chl_add(command_module,command_name,operserv_cmd_trust,command_oper,command_type,command_auth,command_desc);
}
