/* ...............................................................
   : ModServ, modular IRC services, version 2.                   :
   : trustgroup.c                                                :
   : (c) 2005 GamerIRC dev-workx.                                :
   : --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- :
   : This programm is free software, you can redistribute and/or :
   : modify it under the terms of the GNU Public License (GPL).  :
   : You should have received a copy of the license along with   :
   : this program. If not, write to the Free Software Foundation :
   : Inc.,59 Temple Place - Suite 330,Boston,MA 02111-1307, USA. :
   :.............................................................: */

#include "main.h"
#include "modbas.h"
#include "pgsql.h"
#include "ucdata.h"
#include "clients.h"
#include "channels.h"
#include "strfunc.h"
#include "trusts.h"

#define command_module "operserv"
#define command_name   "trustgroup"
#define command_desc   3050
#define command_oper   1
#define command_type   1
#define command_auth   1

void operserv_cmd_trustgroup(char *arg, char *unum, char *target) {
  strarray(arg); char comment[500],cm2[500]; PGresult *res; long dur; trustgroup *tg;
  int i,c=0; long t; trusthost *b; time_t lastusedx;
  if (cargc==0) {
    m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
    m_notice(unum,target,getlang(3051,gu(unum,1)),command_name);
    m_notice(unum,target,"---");
    m_notice(unum,target,getlang(3052,gu(unum,1)),getmodnick(command_module),command_name);
    m_notice(unum,target,getlang(3053,gu(unum,1)));
    m_notice(unum,target,getlang(3032,gu(unum,1)));
    m_notice(unum,target,getlang(3033,gu(unum,1)));
    return;
  } else if (cargc<1) {
    m_notice(unum,target,getlang(8200,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
  if (!strcasecmp(cargs[0],"add")) {
    /* adding a trustgroup */
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(3054,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(3055,gu(unum,1)));
      m_notice(unum,target,getlang(3102,gu(unum,1)));      
      m_notice(unum,target,getlang(3056,gu(unum,1)));
      m_notice(unum,target,getlang(3057,gu(unum,1)));
      m_notice(unum,target,getlang(3058,gu(unum,1)));
      m_notice(unum,target,getlang(3059,gu(unum,1)));
      m_notice(unum,target,getlang(3060,gu(unum,1)));
      m_notice(unum,target,getlang(3061,gu(unum,1)));
      return;
    }
    if (cargc<8) {
      m_notice(unum,target,getlang(3054,gu(unum,1)),command_name);
      return;
    }
    if (!findaccount(cargs[2])) {
      m_notice(unum,target,getlang(8211,gu(unum,1)),cargs[2]);
      return;
    }
    res=pg_query("SELECT * FROM trustgroups WHERE name='%s';",cargs[1]);
    if (pg_num_rows(res)>0) {
      m_notice(unum,target,getlang(3062,gu(unum,1)),cargs[1]);
      PQclear(res);
      return;
    }
    PQclear(res);
    dur=duration2long(cargs[7]);
    if (dur==-1) {
      m_notice(unum,target,getlang(3035,gu(unum,1)));
      return;
    }
    resetchar(comment);
    for(i=8;i<cargc;i++) {
      strcat(comment,cargs[i]);
      if ((i+1)<cargc) {
        strcat(comment," ");
      }
    }
    if (comment[0]=='\0') {
      strcp(comment,"[no comment]");
    }
    addtrustgroup(cargs[1],cargs[2],cargs[3],comment,getauth(unum),atoi(cargs[5]),atoi(cargs[4]),(cargs[6][0]=='y') ? 1 : 0,time(NULL)+dur);
    m_notice(unum,target,getlang(3063,gu(unum,1)),cargs[1],atoi(cargs[4]));
    return;
  } else if (!strcasecmp(cargs[0],"show")) {
    /* display a trustgroup */
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(3064,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(3053,gu(unum,1)));
      return;
    }
    if (cargs[1][0]=='#') {
      tg=gettgbyid(atoi(cargs[1]+1));
    } else {
      tg=gettgbyname(cargs[1]);
    }
    if (tg==NULL) {
      m_notice(unum,target,getlang(3065,gu(unum,1)),cargs[1]);
      return;
    }
    res=pg_query("SELECT address FROM trusthosts WHERE trustgroup=%d;",tg->id);
    resetchar(comment);
    /*if (tg->used<1) {
      strcp(comment,"0%");
    } else {
      sprintf(comment,"%02d%s",(tg->connections/tg->used*100),"%");
    }*/
    for(c=0,lastusedx=0,b=th_list;b!=NULL;b=b->next) {
      if (b->trustgroup->id==tg->id) {
        c+=b->usage;
        if (b->lastused>lastusedx) {
          lastusedx=b->lastused;
        }
      }
    }
    if (c==0) {
      strcp(comment,"0%");
    } else if (c>0) {
      sprintf(comment,"%0.2f%s",(c/tg->connections*100),"%");
    }
    comment[strlen(comment)]=0x00;
    m_notice(unum,target,getlang(3066,gu(unum,1)),tg->name,tg->id);
    m_notice(unum,target,getlang(3067,gu(unum,1)),tg->connections,c,comment);
    m_notice(unum,target,getlang(3068,gu(unum,1)),tg->maxperident,(tg->maxperident==0) ? getlang(3075,gu(unum,1)) : "");
    m_notice(unum,target,getlang(3069,gu(unum,1)),(tg->forceident==0) ? getlang(8205,gu(unum,1)) : getlang(8204,gu(unum,1)));
    m_notice(unum,target,getlang(3070,gu(unum,1)),cctime(lastusedx));
    resetchar(comment);
    t=tg->expire-time(NULL);
    durationcp(t,comment);
    m_notice(unum,target,getlang(3071,gu(unum,1)),cctime(tg->expire),comment);
    m_notice(unum,target,getlang(3072,gu(unum,1)),tg->addedby,cctime(tg->addedat));
    m_notice(unum,target,getlang(3073,gu(unum,1)),tg->contact);
    m_notice(unum,target,getlang(3074,gu(unum,1)),tg->comment);
    m_notice(unum,target,getlang(3076,gu(unum,1)),pg_num_rows(res));
    if (pg_num_rows(res)<1) {
      m_notice(unum,target,getlang(3077,gu(unum,1)));
      PQclear(res);
      return;
    }
    for(b=th_list;b!=NULL;b=b->next) {
      if (b->trustgroup->id==tg->id) {
        m_notice(unum,target,getlang(3078,gu(unum,1)),b->addr,b->maxusage,b->usage,(!b->lastused || b->lastused==0) ? getlang(2322,gu(unum,1)) : cctime((time_t)b->lastused));
      }
    }
    PQclear(res);
    return;
  } else if (!strcasecmp(cargs[0],"edit")) {
    /* update a trustgroup */
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(3079,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(3053,gu(unum,1)));
      m_notice(unum,target,getlang(3080,gu(unum,1)));
      return;
    }
    if (cargs[1][0]=='#') {
      tg=gettgbyid(atoi(cargs[1]+1));
    } else {
      tg=gettgbyname(cargs[1]);
    }
    if (tg==NULL) {
      m_notice(unum,target,getlang(3065,gu(unum,1)),cargs[1]);
      return;
    }
    if (!strcasecmp(cargs[2],"name")) {
      pg_query("UPDATE trustgroups SET name='%s' WHERE id=%d;",cargs[3],tg->id);
      strcp(tg->name,cargs[3]);
    } else if (!strcasecmp(cargs[2],"maxperident")) {
      pg_query("UPDATE trustgroups SET maxperident=%d WHERE id=%d;",atoi(cargs[3]),tg->id);
      tg->maxperident=atoi(cargs[3]);
    } else if (!strcasecmp(cargs[2],"contact")) {
      pg_query("UPDATE trustgroups SET contact='%s' WHERE id=%d;",cargs[3],tg->id);
      strcp(tg->contact,cargs[3]);
    } else if (!strcasecmp(cargs[2],"comment")) {
      pg_query("UPDATE trustgroups SET comment='%s' WHERE id=%d;",cargs[3],tg->id);
      strcp(tg->comment,cargs[3]);
    } else if (!strcasecmp(cargs[2],"connections")) {
      pg_query("UPDATE trustgroups SET connections=%d WHERE id=%d;",atoi(cargs[3]),tg->id);
      tg->connections=atoi(cargs[3]);
    } else if (!strcasecmp(cargs[2],"forceident")) {
      pg_query("UPDATE trustgroups SET forceident=%s WHERE id=%d;",(cargs[3][0]=='y') ? "TRUE" : "FALSE",tg->id);
      if (cargs[3][0]=='y') { tg->forceident=1; } else { tg->forceident=0; }
    } else if (!strcasecmp(cargs[2],"expires")) {
      t=duration2long(cargs[3]);
      if (t==-1) {
        m_notice(unum,target,getlang(3035,gu(unum,1)));
        return;
      }
      pg_query("UPDATE trustgroups SET expires='%ld' WHERE id=%d;",time(NULL)+t,tg->id);
      tg->expire=time(NULL)+t;
    }
    m_notice(unum,target,getlang(3081,gu(unum,1)));
    return;
  } else if (!strcasecmp(cargs[0],"del")) {
    /* remove a trustgroup */
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(3082,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(3053,gu(unum,1)));
      return;
    }
    if (cargs[1][0]=='#') {
      tg=gettgbyid(atoi(cargs[1]+1));
    } else {
      tg=gettgbyname(cargs[1]);
    }
    if (tg==NULL) {
      m_notice(unum,target,getlang(3065,gu(unum,1)),cargs[1]);
      return;
    }
    i=tg->id;
    /* save the id, because it's not accessable after deltrustgroup */
    deltrustgroup(i);
    m_notice(unum,target,getlang(3083,gu(unum,1)),i);
    return;
  } else if (!strcasecmp(cargs[0],"list")) {
    /* list matching trustgroups */
    if (cargc==1) {
      m_notice(unum,target,"\02%s\02 %s",command_name,getlang(command_desc,gu(unum,1)));
      m_notice(unum,target,getlang(3093,gu(unum,1)),command_name);
      m_notice(unum,target,"---");
      m_notice(unum,target,getlang(3094,gu(unum,1)));
      return;
    }
    return;
  } else {
    /* unknown option */
    m_notice(unum,target,getlang(3084,gu(unum,1)),getmodnick(command_module),command_name);
    return;
  }
}

void load_operserv_cmd_trustgroup(void) {
  chl_add(command_module,command_name,operserv_cmd_trustgroup,command_oper,command_type,command_auth,command_desc);
}
