/**********************************************************
 * ModServ2x - Modular IRC Services for advanced use.     *
 *   Based on the Undernet/Beware P10 Protocol.           *
 *   (C) 2004-2005 Christian Jurk (commx@commx.ws)        *
 *   Special thanks goes to:                              *
 *     Stephan Peijnik                                    *
 *     Linus Kimselius                                    *
 * ------------------------------------------------------ *
 * This program is released under the terms of the GNU    *
 * Public License (GPL). You'll find the License in the   *
 * docs directory shipped with this release.              *
 * ------------------------------------------------------ *
 * servers.c                                              *
 * Server-based functions.                                *
 * 21/04/05 12:02 commx                                   *
 **********************************************************/
   
#include "include/main.h"
#include "include/servers.h"

void addserver(char *name, char *snum, time_t sts, time_t bts, char *flags, char *hub) {
  servers *s,*b;
  if (global_debug) {
    flog("addserver","adding new server (%s/%s) [%s]\n",name,snum,flags);
  }
  s=(servers *)myalloc(sizeof(servers));
  strcp(s->name,name);
  strcp(s->snum,snum);
  strcp(s->flags,flags);
  strcp(s->hub,hub);
  s->starttime=sts;
  s->bursttime=bts;
  if (!serv_list) {
    s->next=NULL;
  } else {
    s->next=serv_list;
  }
  serv_list=s;
}

void delserver(char *name) {
  servers *s,*s2=NULL; char hubnum[20];
  resetchar(hubnum);
  for(s=serv_list;s!=NULL;s=s->next) {
    if (!strcmp(s->name,name)) {
      strcp(hubnum,s->snum);
      if (s2==NULL) {
        serv_list=s->next;
      } else {
        s2->next=s->next;
      }
      free(s);
    }
    s2=s;
  }
  for(s=serv_list,s2=NULL;s!=NULL;s=s->next) {
    if (!strcmp(s->hub,hubnum)) {
      if (s2==NULL) {
        serv_list=s->next;
      } else {
        s2->next=s->next;
      }
      free(s);
    }
    s2=s;
  }
}

unsigned int servercount() {
  servers *s; unsigned int a=0;
  for(s=serv_list;s!=NULL;s=s->next,a++);
  return a;
}
