/**********************************************************
 * ModServ2x - Modular IRC Services for advanced use.     *
 *   Based on the Undernet/Beware P10 Protocol.           *
 *   (C) 2004-2005 Christian Jurk (commx@commx.ws)        *
 *   Special thanks goes to:                              *
 *     Stephan Peijnik                                    *
 *     Linus Kimselius                                    *
 * ------------------------------------------------------ *
 * This program is released under the terms of the GNU    *
 * Public License (GPL). You'll find the License in the   *
 * docs directory shipped with this release.              *
 * ------------------------------------------------------ *
 * socket.c                                               *
 * Socket functions.                                      *
 * 21/04/05 12:03 commx                                   *
 **********************************************************/
   
#include "include/socket.h"

int core_sock_connect(char *host, unsigned int port) {
  int fd;
  struct sockaddr_in sin;
  struct hostent *hent;
  
  if ((hent=gethostbyname(host))==NULL) {
    //slog("(core): sock_connect failed: Cannot resolve host!");
    return -1;
  }

  if ((fd=socket(AF_INET,SOCK_STREAM,0))<0) {
    //slog("(core): sock_connect failed: Cannot create socket!");
    return -1;
  }

  sin.sin_family=AF_INET;
  sin.sin_port=htons(port);
  sin.sin_addr=*((struct in_addr *)hent->h_addr_list[0]);
  
  if (connect(fd,(struct sockaddr*) &sin, sizeof(struct sockaddr))<0) {
    //slog("(core): sock_connect failed: Connection refused!");
    return -1;
  }
  
  return fd;
}

char *getipbyhost(char *host) {
  struct hostent *hey; char *res;
  hey=gethostbyname(host);
  if (hey == NULL) {
    return NULL;
  }
  res=inet_ntoa(*(struct in_addr*)hey->h_addr_list[0]);
  return res;
}
